
C %% partial_ijs warning - we are programming partial_ijs stuff in 3 places
C %%                     - and we be over the legal limit for programming

C %% - all these flags - many for extended arrays to be correctly indexed
C ?? flags

C modified Dec.95 to use full OR fractional values in any update file.
C modified Sep.98 to take Vf array from data file + process .... ??

C Program	p K _ C A L C		- JW, Reading, Dec. 93

C Find out ionisable group pKa's from the fd_manager electrostatic
C interaction output.  Probably, we will have various ways of doing this,
C following Bashford and Karplus, and Gilson ...
C The "fd_manager.out" file is read in as "pK_calc.in".
C The various parameters for this run are read in as "pK_calc.ctr"
C ?? output ??

C Update Jan 2000 to include temp_K in the ctr parameter file.

	REAL		av_gp_prot (355), pH_energy (300),
     1			pH_prot (300), pH_gp_prot (355,300),
     2			pK_gps (355), pH_energy_iso (300),
     3			pH_prot_iso (300), gps_sum (355,4),
     4			av_gp_dh (355), pH_gp_dh (355,300),
     5			dh_at_pK (355), pH_ham (300),pH_ham_iso (300),
     6			pH_gp_intE (355,300), av_gp_intE (355),
     7			av_gp_wij (355,355)
	INTEGER		igps (355,4), pH_red (2,300), igps_nres (355),
     1			nq_gps (4), nres_alt (1000)
	CHARACTER*4	gps_type (355), rgps (355), res_alt (1000)
	CHARACTER*1	cgps (355), chn_alt (1000)
	CHARACTER*8	method, fd_dh
	CHARACTER*80	mol_label
	CHARACTER*80	other_file, fd_file, dh_file
	CHARACTER*60	cple_nodh, sc_fix_fd
	LOGICAL		Vf_mod, other_upd, partials, partial_ijs,
     1			dh_allowed (355), couple_nodh, fix_fd

	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				dh_allowed, cgps
	COMMON	/params/	pH_low, pH_top, n_pH, pH_div, method,
     1				red_limit,other_upd,other_file,Vf_mod,
     2				partials, partial_ijs, couple_kT,
     3				mc_steps, pH_fix_mc, fix_mc, temp_K
	COMMON	/this_pH/	av_energy, av_prot, av_gp_prot,
     1				av_prot_iso, av_energy_iso, av_gp_dh,
     2				av_gp_intE, av_gp_wij
	COMMON	/results/	pH_energy, pH_prot, pH_gp_prot,pK_gps,
     1				pH_energy_iso, pH_prot_iso, pH_gp_dh,
     2				dh_at_pK, pH_ham, pH_ham_iso,
     3				pH_gp_intE
	COMMON	/doubleup/	fd_dh, i_read, fd_file, dh_file
	COMMON	/couple/	couple_nodh
	COMMON	/fix_combo_fd/	nalt,fix_fd,res_alt,nres_alt,chn_alt

C Preliminary stuff - with the option for looping over fd and dh i/p.

	CALL	GETENV ('COUPLE_NODH', cple_nodh)
	CALL	leader (cple_nodh, icn)
	IF ((cple_nodh (1:icn) .EQ. 'yes') .OR.
     1      (cple_nodh (1:icn) .EQ. 'T')) THEN
	  couple_nodh	= .TRUE.
	ELSE
	  couple_nodh	= .FALSE.
	END IF

C Added June 05 - for sn FD/DH run with combo-ed conformers, this option
C really should be set - to put all combo-ing scs to FD only (at scf stage).
C If set, will look for scf_alter.in file for combo residues.

	CALL	GETENV ('COMBO_FIX', sc_fix_fd)
	CALL	leader (sc_fix_fd, ifd)
	IF ((sc_fix_fd (1:ifd) .EQ. 'yes') .OR.
     1      (sc_fix_fd (1:ifd) .EQ. 'T')   .OR.
     2	    (sc_fix_fd (1:ifd) .EQ. 'YES')) THEN
	  fix_fd	= .TRUE.
	ELSE
	  fix_fd	= .FALSE.
	END IF

	CALL	read_params

	IF (fd_dh .EQ. 'fdplusdh') THEN
	  i_read	= 1
	  CALL	read_data
	  CALL	average_data (symm_diff_top)
	  i_read	= 2
	  CALL	read_data
	  CALL	average_data (symm_diff_top)
	ELSE
	  CALL	read_data
	  CALL	average_data (symm_diff_top)
	END IF

C The actual stuff.

	pH_div			= (pH_top-pH_low)/FLOAT(n_pH-1)
	DO 600 i_pH		= 1, n_pH
	  pH_here		= pH_low + pH_div*FLOAT(i_pH-1)
	  IF      (method .EQ. 'red_site') THEN
	    CALL	calc_rs (pH_here, n_red_here,n_states_here,
     1				 frei_en_N, frei_en_D)
	    pH_red (1,i_pH)	= n_red_here
	    pH_red (2,i_pH)	= n_states_here
C ??	    pH_energy (i_pH)	= av_energy
	    pH_ham (i_pH)	= av_energy
	    pH_energy (i_pH)	= frei_en_N
	    pH_prot (i_pH)	= av_prot
C ??	    pH_energy_iso (i_pH) = av_energy_iso
	    pH_ham_iso (i_pH)	= av_energy_iso
	    pH_energy_iso (i_pH) = frei_en_D
	    pH_prot_iso (i_pH)	= av_prot_iso
	    DO 400 ig		= 1, n_gps
	      pH_gp_prot (ig,i_pH) = av_gp_prot (ig)
	      pH_gp_intE (ig,i_pH) = av_gp_intE (ig)
	      IF (fd_dh .EQ. 'fdplusdh') THEN
		pH_gp_dh (ig,i_pH) = av_gp_dh (ig)
	      END IF
400	    CONTINUE						! End ig
	  ELSE IF (method .EQ. 'mon_crlo') THEN
	    CALL	calc_mc (pH_here, frei_en_N, frei_en_D)
C ??	    pH_energy (i_pH)	= av_energy
	    pH_ham (i_pH)	= av_energy
	    pH_energy (i_pH)	= frei_en_N
	    pH_prot (i_pH)	= av_prot
C ??	    pH_energy_iso (i_pH) = av_energy_iso
	    pH_ham_iso (i_pH)	= av_energy_iso
	    pH_energy_iso (i_pH) = frei_en_D
	    pH_prot_iso (i_pH)	= av_prot_iso
	    DO 450 ig		= 1, n_gps
	      pH_gp_prot (ig,i_pH) = av_gp_prot (ig)
	      pH_gp_intE (ig,i_pH) = av_gp_intE (ig)
	      IF (fd_dh .EQ. 'fdplusdh') THEN
		pH_gp_dh (ig,i_pH) = av_gp_dh (ig)
	      END IF
450	    CONTINUE						! End ig
	  ELSE
	    STOP 'method is what?'
	  END IF
600	CONTINUE						! End i_pH

C Use the individual group protonation array to find the pK's.
C pK_gps (ig) set at -999. means pK below pH_low, and 999. means above pH_top.

	CALL	get_pKs

C Out put the energy, protonation state, and individual pK's then.

	CALL	output (av_gp_wij, pH_red, symm_diff_top)

	CALL	EXIT
	END


	SUBROUTINE	read_params
C	**********	***********

C Not much to get from the "pK_calc.ctr" file.

	CHARACTER*8	check, method, fd_dh
	CHARACTER*80	other_file, pK_file,
     1			fd_file, dh_file
	LOGICAL		Vf_mod, other_upd, partials, partial_ijs,
     1			pK_update, fix_fd, scf_alt_over (355)
	CHARACTER*10	dh_choice
	CHARACTER*80	rec, line, line_strip
	CHARACTER*4	scf_res (355), res_alt (1000)
	INTEGER		scf_nres (355), nres_alt (1000)
	LOGICAL*1	scf (355)
	CHARACTER*80	scf_file
	CHARACTER*1	scf_chain (355), chn_alt (1000)

	COMMON	/params/	pH_low, pH_top, n_pH, pH_div, method,
     1				red_limit,other_upd,other_file,Vf_mod,
     2				partials, partial_ijs, couple_kT,
     3				mc_steps, pH_fix_mc, fix_mc, temp_K
	COMMON	/doubleup/	fd_dh, i_read, fd_file, dh_file
	COMMON	/pk_upd/	pK_update, pK_file
	COMMON	/dh_from_scs/	n_scf, scf_res, scf_nres, scf,
     1				scf_chain, dh_choice, scf_alt_over
	COMMON	/fix_combo_fd/	nalt,fix_fd,res_alt,nres_alt,chn_alt

1100	FORMAT (A8)
C??1200	FORMAT (Q,60A1)
1240	FORMAT (A8)
1260	FORMAT (A10)
1300	FORMAT (A80)
1310	FORMAT (A4)
1320	FORMAT (I4)
1330	FORMAT (A1)
1400	FORMAT (A1,2X,A4,1X,I5)
2100	FORMAT (' *** "mean_fld" not yet programmed')
2300	FORMAT (' *** didn"t recognise the "method"')

9000	FORMAT (' *** error in record flag in "pK_calc.ctr"')
9100	FORMAT (' *** come on now, n_pH .gt. 300 is excessive')
9200	FORMAT (' *** updated with temp_K input - provide')

	OPEN (UNIT=1, NAME='pk_calc.ctr', TYPE='OLD')

C The resolution and the limits for the titration curve.

	READ (1,1100) check
	IF (check .NE. 'n_points') GOTO 900
	READ (1,*) n_pH
	IF (n_pH .GT. 300) GOTO 910
	READ (1,1100) check
	IF (check .NE. 'pH range') GOTO 900
	READ (1,*) pH_low, pH_top

C Update Jan 2000 for parameter input of the the temperature.

	READ (1,1100) check
	IF (check .NE. 'tempture') GOTO 920
	READ (1,*) temp_K

C Which calculation method to get the pK's and titration curve?

	READ (1,1100) check
	IF (check .NE. 'method  ') GOTO 900
C ??	READ (1,1100) method
	READ (1,1300) line
	CALL	get_filename (line, line_strip)
	READ (line_strip,1100) method
	IF	(method .EQ. 'mean_fld') THEN
	  WRITE (6,2100)
	  CALL	EXIT
	ELSE IF (method.NE.'red_site' .AND. method.NE.'mon_crlo') THEN
	  WRITE (6,2300)
	  CALL	EXIT
	END IF

C Read in the percentage of the protonation state tails that we cut off -
C it will be the same for each end. (in the reduced site method) eg 5 %.

	READ (1,1100) check
	IF (check .NE. 'red_lims') GOTO 900
	READ (1,*) red_limit

C Need a starting point for the delG incremental (Q-based) mc calculation,
C (kT units for fix_mc).

	READ (1,1100) check
	IF (check .NE. 'mc_pHlim') GOTO 900
	READ (1,*) pH_fix_mc, fix_mc

C Read in the coupling value (kT units) defining strongly interacting sites
C in the monte carlo method, and then the number of mc steps.

	READ (1,1100) check
	IF (check .NE. 'coupling') GOTO 900
	READ (1,*) couple_kT

	READ (1,1100) check
	IF (check .NE. 'mc_steps') GOTO 900
	READ (1,*) mc_steps

C Find out whether we are processing 1 or 2 runs (fd/dh) ?

C ??	DO 1018 ic	= 1, 60
C ??	  fd_file (ic)	= ' '
C ??	  dh_file (ic)	= ' '
C ??1018CONTINUE						! End ic

	READ (1,1100) check
	IF (check .NE. 'fd+dh?  ') GOTO 900
C ??	READ (1,1240) fd_dh
	READ (1,1300) line
	CALL	get_filename (line, line_strip)
	READ (line_strip,1240) fd_dh
	IF ((fd_dh.NE.'fdplusdh').AND.(fd_dh.NE.'fd_only ').AND.
     1	    (fd_dh.NE.'dh_only ')) STOP 'fd_dh problem'
	READ (1,1100) check
	IF (check .NE. 'fd_file ') GOTO 900
	IF ((fd_dh.EQ.'fdplusdh').OR.(fd_dh.EQ.'fd_only ')) THEN
C ??	  READ (1,1200) nc, (fd_file (ic), ic=1,nc)
	  READ (1,1300) line
	  CALL	get_filename (line, fd_file)
	ELSE
	  READ (1,*)
	END IF
	READ (1,1100) check
	IF (check .NE. 'dh_file ') GOTO 900
	IF ((fd_dh.EQ.'fdplusdh').OR.(fd_dh.EQ.'dh_only ')) THEN
C ??	  READ (1,1200) nc, (dh_file (ic), ic=1,nc)
	  READ (1,1300) line
	  CALL	get_filename (line, dh_file)
	ELSE
	  READ (1,*)
	END IF

	READ (1,1100) check
	IF (check .NE. 'dhchoice') GOTO 900
C ??	READ (1,1260) dh_choice
	READ (1,1300) line
	CALL	get_filename (line, line_strip)
	READ (line_strip,1260) dh_choice
	IF ((dh_choice.NE.'volumefrac') .AND.
     1	    (dh_choice.NE.'sc_freedom')) STOP 'dh_choice?'

C OCT.2001 ?? temporary stop here while we alter i/p to get scf_chain.
C??	IF (dh_choice .EQ. 'sc_freedom') STOP 'update scf_chain i/p'

C June 05 - if fix_fd is set then we make sure that all aas from scf_alter.in
C are 'NO_DH' - since they will be conformationally varied anyhow.

	IF (fix_fd) THEN
	  IF (dh_choice .NE. 'sc_freedom') STOP 'fix_fd / not scf'
	  OPEN (UNIT=3, NAME='scf_alter.in', TYPE='OLD')
	  nalt		= 0
306	  nalt		= nalt + 1
	  IF (nalt .GT. 1000) STOP 'nalt > 1000'
	  READ (3,1400,END=308) chn_alt(nalt), res_alt(nalt),
     1				nres_alt(nalt)
	  GOTO 306

308	  nalt		= nalt - 1
	  CLOSE (UNIT=3)
	END IF

	IF (dh_choice .EQ. 'sc_freedom') THEN
C ??	  READ (1,1200) nc, (scf_file (ic), ic=1,nc)
	  READ (1,1300) line
	  CALL	get_filename (line, scf_file)
	  OPEN (UNIT=3, NAME=scf_file, TYPE='OLD')
	  n_scf		= 0
320	  READ (3,1300,END=340) rec
	  IF (rec (1:1) .EQ. '>') THEN
	    n_scf		= n_scf + 1
	    IF (n_scf .GT. 355) STOP 'n_scf > 355'
	    READ (rec (3:6),1310) scf_res (n_scf)
	    READ (rec (11:14),1320) scf_nres (n_scf)
	    READ (rec (8:8),1330) scf_chain (n_scf)
	    IF (rec (63:67) .EQ. 'NO_DH') THEN
	      scf (n_scf)	= .FALSE.
	    ELSE
	      scf (n_scf)	= .TRUE.
	      IF (fix_fd) THEN
	        scf_alt_over (n_scf) = .FALSE.
		DO 326 ialt	= 1, nalt
		  IF ((chn_alt(ialt) .EQ. scf_chain(n_scf)) .AND.
     1		      (res_alt(ialt) .EQ. scf_res(n_scf))   .AND.
     2		      (nres_alt(ialt).EQ. scf_nres(n_scf))) THEN
		    scf (n_scf) = .FALSE.
		    scf_alt_over (n_scf) = .TRUE.
		  END IF
326		CONTINUE					! End ialt
	      END IF
	    END IF
	  END IF
	  GOTO 320
340	  CLOSE (UNIT=3)
	ELSE
	  READ (1,*)
	END IF

C ??	DO 1082 ic		= 1, 60
C ??	  pK_file (ic)		= ' '
C ??	  other_file (ic)	= ' '
C ??1082CONTINUE						! End ic

C ?? We have (Sep.2001) taken this option out, and have gone back with updates
C ?? to atoms_es.dat - it is ugly assigning model compound pKas twice!

C ??	READ (1,1100) check
C ??	IF (check .NE. 'pKupdate') GOTO 900
C ??	READ (1,*) pK_update
C ??	IF (pK_update) THEN
C ??	  READ (1,1200) nc, (pK_file (ic), ic=1,nc)
C ??	ELSE
C ??	  READ (1,*)
C ??	END IF

C We now have an option (for fd i/p) to modify SE by a TdelS term derived
C from the passed Vfs, and a store of ionisable group N values.
C We also maintain an option to read in a further file of specific SE or FX
C updates (for fd i/p only).  Hopefully we won't be using this.

	IF (fd_dh .EQ. 'dh_only ') THEN
	  READ (1,*)
	  READ (1,*)
	  READ (1,*)
	  READ (1,*)
	  READ (1,*)
	ELSE
	  READ (1,1100) check
	  IF (check .NE. 'Vf_modSE') GOTO 900
	  READ (1,*) Vf_mod
	  READ (1,1100) check
	  IF (check .NE. 'OtherUPD') GOTO 900
	  READ (1,*) other_upd
	  IF (other_upd) THEN
C ??	    READ (1,1200) nc, (other_file (ic), ic=1,nc)
	    READ (1,1300) line
	    CALL	get_filename (line, other_file)
	  ELSE
	    READ (1,*)
	  END IF
	END IF

C ?? karolinska at present its not clear to me whether we should be using the
C ?? auto Vf or 'fd_dh ' analyses with the partials options.  Put a note to
C ?? this effect in the output file.

C We want to know whether we will be working out pKa's based on the full
C charge analysis (+/- 1 on ionisables, differenced with zero), or with
C the partial charge analysis (partially charge +/- 1 ionisables,
C differenced with partially charged neutral forms).
C A few points to note here.  We only do one calculation for each pK_calc run.
C Even with the partially charged gear, we need the fully charged Q_set done,
C to assign acid or base reliably on the basis of sign of charge.
C Currently we will just average the 2 neutral partially charged forms for
C differencing with the +/-1 partially charged form.  In the future we may
C consider trying to put some statistical weights in there.  We hope already
C to have excluded really nasty partial charge configurations with a graphics
C analysis, and simply repeating any singly allowed form in both neutral sets.

C The partial_ijs flag swicthes on a partial charge analysis also of wij's,
C as well of se and fix.

	READ (1,1100) check
	IF (check .NE. 'partials') GOTO 900
	READ (1,*) partials
	READ (1,1100) check
	IF (check .NE. 'prtl_ijs') GOTO 900
	READ (1,*) partial_ijs

	CLOSE (UNIT=1)
	RETURN

900	WRITE (6,9000)
	CALL	EXIT

910	WRITE (6,9100)
	CALL	EXIT

920	WRITE (6,9200)
	CALL	EXIT
	END


	SUBROUTINE	read_data
C	**********	*********

C Read in the charge interaction data from the fd/dh_manager run.

	REAL		se (355,2,3,10,4),char (355,10,4),pKint (355),
     1			xyz (355,10,3,4), fix (355,2,3,4),
     2			gpij(355,3,355,10,4),
     3			fix_xyz (3,10000), fix_q (10000),
     4			gps_sum (355,4), Vf (355,3)
	INTEGER		qopind (355,10,4), fix_nres (10000),
     1			igps (355,4), igps_nres (355), nq_gps (4),
     2			ind_xyz (355,10,4)
	CHARACTER*4	gps_type (355), rgps (355),
     1			fix_res (10000), fix_atyp (10000)
	CHARACTER*8	state, fd_dh
	CHARACTER*80	mol_label
	LOGICAL		extra_runs, Q_set (5)
	LOGICAL*1	done (355,2,3,4)
	CHARACTER*80	Q_file (5), coords_file (5)
C ??	BYTE		Q_file (5,60), coords_file (5,60)
	CHARACTER*80	fd_file, dh_file
	REAL		gps_sum1 (355,4), pKint1 (355)
	CHARACTER*4	gps_type1 (355), rgps1 (355)
	CHARACTER*1	cgps (355), fix_chain (10000), cgps1 (355)
	INTEGER		igps1 (355,4), igps_nres1 (355)
	LOGICAL		Q_set1 (5), dh_allowed (355)

	COMMON	/various/	extra_runs, state, i_gp_here, pH
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				dh_allowed, cgps
	COMMON	/gps_data/ dum, done, se, char, xyz, fix, gpij, pKint,
     1				qopind, ind_xyz, Vf
	COMMON	/fix_data/	nq_fix,fix_xyz, fix_q, fix_nres,
     1				fix_res, fix_atyp, fix_chain
	COMMON	/charges_in/	n_Q_sets, Q_set, i_Q_here, i_Q_done
	COMMON	/doubleup/	fd_dh, i_read, fd_file, dh_file
	COMMON	/buffer2/	n_Q_sets1, n_gps1, Q_set1, igps1,
     1				igps_nres1, rgps1, gps_sum1,
     2				gps_type1, pKint1, cgps1
	COMMON	/pI_data/	num_acids, num_bases, sum_fixQ

	IF	(fd_dh .EQ. 'fdplusdh') THEN
	  IF	  (i_read .EQ. 1) THEN
	    OPEN (UNIT=1, NAME=fd_file, TYPE='OLD',
     1		  FORM='UNFORMATTED')
	  ELSE IF (i_read .EQ. 2) THEN
	    OPEN (UNIT=1, NAME=dh_file, TYPE='OLD',
     1		  FORM='UNFORMATTED')
	  ELSE
	    STOP 'i_read/fd+dh'
	  END IF
	ELSE IF (fd_dh .EQ. 'fd_only ') THEN
	  OPEN (UNIT=1, NAME=fd_file, TYPE='OLD',
     1		FORM='UNFORMATTED')
	ELSE IF (fd_dh .EQ. 'dh_only ') THEN
	  OPEN (UNIT=1, NAME=dh_file, TYPE='OLD',
     1		FORM='UNFORMATTED')
	END IF

	READ (1) mol_label
	READ (1) i_gp_here, i_Q_here
	READ (1) n_Q_sets, i_Q_done, i_Q_todo, (Q_set (j), j=1,5),
     1		 (Q_file (j), j=1,5)
	READ (1) (coords_file (j), j=1,5)
	READ (1) n_gps, (nq_gps (m), m=1,4), extra_runs
	READ (1) ((igps (i,j), j=1,4), i=1,n_gps),
     1		 (igps_nres (i), i=1,n_gps),
     2		 (cgps (i), i=1,n_gps)
	READ (1) (((ind_xyz (i,j,k), k=1,4), j=1,10), i=1,n_gps)
	READ (1) (rgps(i),i=1,n_gps),((gps_sum(i,j),j=1,4),i=1,n_gps)
	READ (1) (gps_type (i), i=1,n_gps)
	READ (1) ((((done (i,j,k,m), m=1,4), k=1,3), j=1,2),
     1		     i=1,n_gps)
	READ (1) (((((se (i,j,k,l,m), m=1,4), l=1,10), k=1,3),
     1		      j=1,2), i=1,n_gps)
	READ (1) (((char (i,j,m), m=1,4), j=1,10), i=1,n_gps)
	READ (1) ((((xyz (i,j,k,m), m=1,4), k=1,3),j=1,10),i=1,n_gps)
	READ (1) ((((fix (i,j,k,m), m=1,4), k=1,3), j=1,2),i=1,n_gps)
	READ (1) (((((gpij(i,j,k,l,m), m=1,4), l=1,10), k=1,n_gps),
     1		      j=1,3), i=1,n_gps)
	READ (1) (pKint (i), i=1,n_gps)
	READ (1) ((Vf (i,j), j=1,3), i=1,n_gps)
	READ (1) (((qopind (i,j,m), m=1,4), j=1,10), i=1,n_gps)
	READ (1) nq_fix
	sum_fixQ	= 0.
	DO 200 i	= 1, nq_fix
	  READ (1) (fix_xyz (j,i), j=1,3), fix_q (i), fix_res (i),
     1		    fix_atyp (i), fix_nres (i), fix_chain (i)
	  sum_fixQ	= sum_fixQ + fix_q (i)
200	CONTINUE						! End i
	CLOSE (UNIT=1)

C If we are doing fd and dh, then buffer some stuff (i_read=1) or check it (2).

	IF (fd_dh .EQ. 'fdplusdh') THEN
	  IF	  (i_read .EQ. 1) THEN
	    n_Q_sets1		= n_Q_sets
	    n_gps1		= n_gps
	    DO 260 j		= 1, 5
	      Q_set1 (j)	= Q_set (j)
260	    CONTINUE						! End j
	    DO 400 i		= 1, n_gps
	      igps_nres1 (i)	= igps_nres (i)
	      cgps1 (i)		= cgps (i)
	      rgps1 (i)		= rgps (i)
	      gps_type1 (i)	= gps_type (i)
	      pKint1 (i)	= pKint (i)
	      DO 300 j		= 1, 4
		igps1 (i,j)	= igps (i,j)
		gps_sum1 (i,j)	= gps_sum (i,j)
300	      CONTINUE						! End j
400	    CONTINUE						! End i
	  ELSE IF (i_read .EQ. 2) THEN
	    IF (n_Q_sets	.NE. n_Q_sets1)	STOP 'n_Q_sets1'
	    IF (n_gps		.NE. n_gps1)	STOP 'n_gps1'
	    DO 360 j		= 1, 5
	      IF (Q_set (j)	.NEQV. Q_set1 (j)) STOP 'Qset1'
360	    CONTINUE						! End j
	    DO 600 i		= 1, n_gps
	      IF (igps_nres (i)	.NE. igps_nres1 (i)) STOP 'igps_nres1'
	      IF (cgps (i)	.NE. cgps1 (i)) STOP 'cgps1'
	      IF (rgps (i)	.NE. rgps1 (i))	STOP 'rgps1'
	      IF (gps_type (i)	.NE. gps_type1 (i)) STOP 'gps_type1'
	      IF (pKint (i)	.NE. pKint1 (i)) STOP 'pKint1'
	      DO 500 j		= 1, 4
		IF (igps (i,j)	.NE. igps1 (i,j)) STOP 'igps1'
		IF (gps_sum (i,j) .NE. gps_sum1(i,j)) STOP 'gps_sum1'
500	      CONTINUE						! End j
600	    CONTINUE						! End i
	  ELSE
	    STOP 'fd+dh/i_read'
	  END IF
	END IF

	RETURN
	END


	SUBROUTINE	average_data (symm_diff_top)
C	**********	************

C Updating, Sep.98, for fd_dh, we are doubling up just the se_diff, fix_diff
C and wij arrays.

C NOTE THAT average_data returns the se_diff, fix_diff and wij arrays
C with the energies that would accrue with FULL ionisation of the
C relevant groups.  It is therefore assumed that there is NO CHARGE in
C the UNIONISED form ??
C ?? Also we would need to divide the charge back for any mean-field
C    calculation of pK's.
C The se_diff, fix_diff and wij values are all in kT per molecule units, with:
C	positive for unfavourable transfer solvent to protein, and
C	negative for   favourable transfer solvent to protein.
C The start index of the se_diff, fix_diff and wij arrays is fd (1) or dh (2)
C if we are using both i/ps - otherwise the lone input is 1 on the start index.
C Other slots are 1 for unprotonated form, and 2 for the protonated form.

C igps_nres is nres.  igps (i,x) is counter of the Q bits found for gps i as
C we read in the escalc.qop file x.  gps_sum (i,x) is a sum check on the
C amount of charge read in - we'll check it against 0/+-1.

C ind_xyz (igp,i bit of gp,i_Q) - index of i bit in gpij array
C done (igp/i protein or alone run/i foc cen run,i_Q)		- run done?
C fix  (igp/i protein or alone run/i foc cen run,i_Q)		- fixd Qs sum
C se   (......................................../i bit of gp,i_Q) - se potl
C char (igp/i bit of gp,i_Q)					- Q of bit
C xyz  (igp/i bit of gp/1-3,i_Q)				- xyz of bit
C gpij (igp/i foc cen run/j gp/bit ind_here/i_Q)-(only prot run)-ptls at j bits
C	where the "bit ind_here" index comes from ind_xyz
C pKint (igp)							- pKint
C qopind (igp/i bit of gp,i_Q)					- iq in qop

C fix arrays are clear - nres/res allow match up with aa of a gp.

	REAL		se (355,2,3,10,4),char (355,10,4),pKint (355),
     1			xyz (355,10,3,4), fix (355,2,3,4),
     2			gpij(355,3,355,10,4),
     3			fix_xyz (3,10000), fix_q (10000),
     4			pK_int (355),gps_sum (355,4), Vf (355,3)
	REAL		se_diff_prtl(4), fix_diff_prtl(4),
     1			wij_prtl, wij_prtl2 (4,4)
	INTEGER		qopind (355,10,4), fix_nres (10000),
     1			igps (355,4), igps_nres (355), nq_gps (4),
     2			ind_xyz (355,10,4)
	CHARACTER*4	group (355), rgps (355), code, res,
     1			fix_res (10000), fix_atyp (10000)
	CHARACTER*8	state, fd_dh
	CHARACTER*80	mol_label
	LOGICAL		extra_runs
	LOGICAL*1	done (355,2,3,4)
	REAL		se_diff (2,2,355), fix_diff (2,2,355),
     1			wij (2,2,355,2,355), nat10,
     2			pK_old (20), pK_new (20), res_upd (20)
	CHARACTER*4	gps_type (355), status (355)
	CHARACTER*1	cgps (355), fix_chain (10000)
	CHARACTER*8	method
	CHARACTER*80	other_file, pK_file, fd_file, dh_file
	LOGICAL		Vf_mod, other_upd, partials, partial_ijs,
     1			Q_set (5), percent, pK_update,shell_found,
     2			dh_allowed (355), couple_nodh, fix_fd,
     3			scf_alt_over (355)
	CHARACTER*10	dh_choice
	CHARACTER*4	scf_res (355), res_alt (1000)
	INTEGER		scf_nres (355), nres_alt (1000)
	LOGICAL*1	scf (355)
	CHARACTER*1	scf_chain (355), chain, chn_alt (1000)

	COMMON	/pk_upd/	pK_update, pK_file
	COMMON	/params/	pH_low, pH_top, n_pH, pH_div, method,
     1				red_limit,other_upd,other_file,Vf_mod,
     2				partials, partial_ijs, couple_kT,
     3				mc_steps, pH_fix_mc, fix_mc, temp_K
	COMMON	/constants/	bolt, elec, enat, avagad, nat10
	COMMON	/various/	extra_runs, state, i_gp_here, pH
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				dh_allowed, cgps
	COMMON	/gps_data/ dum, done, se, char, xyz, fix, gpij, pKint,
     1				qopind, ind_xyz, Vf
	COMMON	/fix_data/	nq_fix,fix_xyz, fix_q, fix_nres,
     1				fix_res, fix_atyp, fix_chain
	COMMON	/interact/	se_diff, fix_diff, wij
	COMMON	/std_energy/	group, pK_int, status
	COMMON	/charges_in/	n_Q_sets, Q_set, i_Q_here, i_Q_done
	COMMON	/doubleup/	fd_dh, i_read, fd_file, dh_file
	COMMON	/dh_from_scs/	n_scf, scf_res, scf_nres, scf,
     1				scf_chain, dh_choice, scf_alt_over
	COMMON	/pI_data/	num_acids, num_bases, sum_fixQ
	COMMON	/couple/	couple_nodh
	COMMON	/fix_combo_fd/	nalt,fix_fd,res_alt,nres_alt,chn_alt

1100	FORMAT (I4,2X,A4,2X,A4,2X,I1,2X,F6.1,2X,F6.1)
1200	FORMAT (A80,/)
1260	FORMAT (12X,'Do ',I3,' updates addnal to Vf_mod/AVOID THIS?')
1300	FORMAT ('            nres   res   ig  updated (e.mV)
     1 val_old',/)
1400	FORMAT (' SE  update ',I4,2X,A4,2X,I3,3X,F6.1,4X,F6.1)
1500	FORMAT (' FIX update ',I4,2X,A4,2X,I3,3X,F6.1,4X,F6.1)
1600	FORMAT (/,20X,I3,' ADDNAL updates successfully done - WHY?')
1700	FORMAT (' ',78('-'))
1800	FORMAT (' WEIRD-char and gpij first elts = ',E12.4,2X,E12.4)
2000	FORMAT (A4,2X,F6.2,2X,F6.2)
2100	FORMAT (/,I4,' from ',I4,' gps pK updated for this i/p file')
2160	FORMAT (/,' fd+dh option - work out allowed DH from Vf gear',/)
2162	FORMAT (/,' fd+dh option - get allowed DH from SC_F gear',/)
2180	FORMAT ('For group',I5,2X,A4,2X,A1,I4,' Vf   says  DH is ',A10)
2182	FORMAT ('For group',I5,2X,A4,2X,A1,I4,' SC_F says  DH is ',A10)
2183	FORMAT ('For group',I5,2X,A4,2X,A1,I4,' SC_F blank:setDH ',A10)
2184	FORMAT ('For group',I5,2X,A4,2X,A1,I4,' SC_F blank:setDH ',A10)
2186	FORMAT ('For group',I5,2X,A4,2X,A1,I4,' COMBO OVERIDE DH ',A10)
2190	FORMAT (/,14X,' *** Updating SE values with Vf mod ***',/)
2195	FORMAT ('  ig    res   nres  shell   frac  apply before
     1  after',/)
2198	FORMAT (/,' *** YAK - unknown pKa for ',A4,2X,F5.1,
     1' - shell set to 75')
2200	FORMAT (I5,2X,A4,2X,A1,I4,1X,F6.1,1X,F6.2,3(1X,F6.1))
2410	FORMAT (/,' partials 	= T  -  partials in SE/FX analysis')
2415	FORMAT (/,' partials	= F')
2420	FORMAT (/,' partial_ijs	= T  -  partials in Wij analysis')
2425	FORMAT (/,' partial_ijs	= F')
2430	FORMAT (/,' Vf_mod	= T  -  SE update by Vf-based factor')
2435	FORMAT (/,' Vf_mod	= F')
2440	FORMAT (/,' fd_dh = "fdplusdh" -  FD/DH switching by Vf_bg')
2445	FORMAT (/,' fd_dh.ne."fdplusdh"')
2450	FORMAT (/,' *** HOW DO THE ABOVE INTERACT ? - CAREFUL ***')
2470	FORMAT (A1,1X,A4,1X,I5)

9000	FORMAT ('*** acid/base not identified')
9100	FORMAT ('*** acid/base not set in group array')
9200	FORMAT ('*** problem reading through update file')
9300	FORMAT ('*** we cannot find an update file residue in gps')
9400	FORMAT ('*** we do not recognise the update code')
9450	FORMAT ('0','*** Q_set (.) is not set true ')
9500	FORMAT ('0','*** actually n_gps_done = 0 - drop-out')
9600	FORMAT ('0','*** we should have n_gps_done = n_gps')
9700	FORMAT ('0','*** bit index ind_here is oub')

	IF	(fd_dh .EQ. 'fdplusdh') THEN
	  IF (i_read .EQ. 1) THEN
	    OPEN (UNIT=2, NAME='pk_calc.out', TYPE='NEW')
	    WRITE (2,1700)
	    WRITE (2,*) 'fd+dh run - info for the fd input file'
	    WRITE (2,1200) mol_label
	    iz	= 1
	  ELSE
	    WRITE (2,*) 'fd+dh run - info for the dh input file'
	    WRITE (2,1200) mol_label
	    iz	= 2
	  END IF
	ELSE IF (fd_dh .EQ. 'fd_only ') THEN
	  OPEN (UNIT=2, NAME='pk_calc.out', TYPE='NEW')
	  WRITE (2,1700)
	  WRITE (2,*) 'fdonly run - info for the fd input file'
	  WRITE (2,1200) mol_label
	  iz	= 1
	ELSE IF (fd_dh .EQ. 'dh_only ') THEN
	  OPEN (UNIT=2, NAME='pk_calc.out', TYPE='NEW')
	  WRITE (2,1700)
	  WRITE (2,*) 'dhonly run - info for the dh input file'
	  WRITE (2,1200) mol_label
	  iz	= 1
	END IF

C %% This bit is truly WEIRD - we appear to be able to alleviate the ALPHA
C    access violation problems with this following write out line, and
C    maybe also with the "dum" scalar on the front of the /gps_data/
C    common - see also list_data.

	WRITE (2,1700)
	WRITE (2,1800) char (1,1,1), gpij (1,1,1,1,1)

C ?? Now put this - not sure about options combination note in.

	IF ((fd_dh.EQ.'fdplusdh') .AND. (i_read.EQ.2)) GOTO 155

	IF (partials) THEN
	  WRITE (2,2410)
	ELSE
	  WRITE (2,2415)
	END IF
	IF (partial_ijs) THEN
	  WRITE (2,2420)
	ELSE
	  WRITE (2,2425)
	END IF
	IF (Vf_mod) THEN
	  WRITE (2,2430)
	ELSE
	  WRITE (2,2435)
	END IF
	IF (fd_dh .EQ. 'fdplusdh') THEN
	  WRITE (2,2440)
	ELSE
	  WRITE (2,2445)
	END IF
	WRITE (2,2450)

155	CONTINUE

C Check that we have always done the chr_unit run, and all the others too
C if partials is set.

	IF (.NOT. Q_set (1)) GOTO 945
	IF (.NOT. Q_set (2)) GOTO 945
	IF (partials) THEN
	  IF (.NOT. Q_set (3)) GOTO 945
	  IF (.NOT. Q_set (4)) GOTO 945
	  IF (.NOT. Q_set (5)) GOTO 945
	END IF

	DO 210 i		= 1, n_gps
	  IF (.NOT. done (i,1,1,1)) THEN
	    IF (i .EQ. 1) GOTO 950
	    GOTO 960
	  END IF
	  IF (partials) THEN
	    DO 205 i_Q_here	= 2, 4
	      IF (.NOT. done (i,1,1,i_Q_here)) THEN
		IF (i .EQ. 1) GOTO 950
		GOTO 960
	      END IF
205	    CONTINUE						! End i_Q_here
	  END IF
210	CONTINUE						! End i

	DO 220 ig	= 1, n_gps
	  pK_int (ig)	= pKint (ig)
220	CONTINUE						! End ig

C We have the option of resetting pK's, based on residue type AND knowing
C what the previous pK was - from external file.
C ?? We have (Sep.2001) taken this option out, and have gone back with updates
C ?? to atoms_es.dat - it is ugly assigning model compound pKas twice!

C ??	IF (pK_update) THEN
C ??	  OPEN (UNIT=3, NAME=pK_file, TYPE='OLD', READONLY)
C ??	  READ (3,*)
C ??	  READ (3,*) n_pK_upd
C ??	  IF (n_pK_upd .GT. 20) STOP 'n_pK_upd .gt. 20'
C ??	  DO 230 iu		= 1, n_pK_upd
C ??	    READ (3,2000) res_upd (iu), pK_old (iu), pK_new (iu)
C ??230	  CONTINUE						! End i_upd
C ??	  CLOSE (UNIT=3)
C ??	  n_updated		= 0
C ??	  DO 270 ig		= 1, n_gps
C ??	    DO 250 iu		= 1, n_pK_upd
C ??	      IF (rgps (ig) .EQ. res_upd (iu)) THEN
C ??		IF (ABS(pK_int(ig)-pK_old(iu)) .LT. 0.0001) THEN
C ??		  pK_int (ig)	= pK_new (iu)
C ??		  n_updated	 = n_updated + 1
C ??		  GOTO 270
C ??		END IF
C ??	      END IF
C ??250	    CONTINUE						! End iu
C ??270	  CONTINUE						! End ig
C ??	  WRITE (2,2100) n_updated, n_gps
C ??	END IF

C We will set acid or base from the full charge, whether partials = T or F.
C Also count up number of acids and bases for pI calculation data output.

	num_acids	= 0
	num_bases	= 0
	DO 300 ig	= 1, n_gps
	  IF      (char (ig,1,1) .GT. 0.) THEN
	    group (ig)	= 'BASE'
	    num_bases	= num_bases + 1
	  ELSE IF (char (ig,1,1) .LT. 0.) THEN
	    group (ig)	= 'ACID'
	    num_acids	= num_acids + 1
	  ELSE
	    GOTO 900
	  END IF
300	CONTINUE						! End ig

C We will process in bits to make the code manageable.
C First will be the simple partials=F analysis, and second the partials=T
C combination.  Within each, we'll go se, fix, wij.

	IF (.NOT. partials) THEN

C .not. partials - se

	  IF (extra_runs) THEN
	    if_max			= 3
	  ELSE
	    if_max			= 1
	  END IF
	  DO 340 ig		= 1, n_gps
	    se_diff_av		= 0.
	    DO 320 if		= 1, if_max
	      se_1		= 0.
	      se_2		= 0.
	      DO 310 ib	= 1, igps (ig,1)
		se_1		= se_1 +
     1				  char (ig,ib,1)*se (ig,1,if,ib,1)
		se_2		= se_2 +
     1				  char (ig,ib,1)*se (ig,2,if,ib,1)
310	      CONTINUE					! End ib
	    se_diff_av	= se_diff_av + se_1 - se_2
320	    CONTINUE						! End if
C ?? self-energy divide by 2
	    se_diff_av	= se_diff_av / (2.*FLOAT (if_max))
	    IF      (group (ig) .EQ. 'ACID') THEN
	      se_diff (iz,1,ig)	= se_diff_av
	      se_diff (iz,2,ig)	= 0.
	    ELSE IF (group (ig) .EQ. 'BASE') THEN
	      se_diff (iz,1,ig)	= 0.
	      se_diff (iz,2,ig)	= se_diff_av
	    ELSE
	      GOTO 910
	    END IF
340	  CONTINUE						! End ig

C .not. partials - fix

	  IF (extra_runs) THEN
	    if_max			= 3
	  ELSE
	    if_max			= 1
	  END IF
	  DO 360 ig		= 1, n_gps
	    fix_diff_av	= 0.
	    DO 350 if		= 1, if_max
	      fix_1		= fix (ig,1,if,1)
	      fix_2		= fix (ig,2,if,1)
	      fix_diff_av	= fix_diff_av + fix_1 - fix_2
350	    CONTINUE						! End if
	    IF      (group (ig) .EQ. 'ACID') THEN
	      fix_diff (iz,1,ig) = fix_diff_av / FLOAT (if_max)
	      fix_diff (iz,2,ig) = 0.
	    ELSE IF (group (ig) .EQ. 'BASE') THEN
	      fix_diff (iz,1,ig) = 0.
	      fix_diff (iz,2,ig) = fix_diff_av / FLOAT (if_max)
	    ELSE
	      GOTO 910
	    END IF
360	  CONTINUE						! End ig

C .not. partials - wij

	  IF (extra_runs) THEN
	    if_max			= 3
	  ELSE
	    if_max			= 1
	  END IF
	  DO 410 ig		= 1, n_gps
	    DO 400 jg		= 1, n_gps
	      IF (jg .EQ. ig) GOTO 400
	      wij_av		= 0.
	      DO 380 if		= 1, if_max
		wij_here	= 0.
		DO 370 jb	= 1, igps (jg,1)
		  ind_here	= ind_xyz (jg,jb,1)
		  IF (ind_here.LT.1.OR.ind_here.GT.10) GOTO 970
		  wij_here	= wij_here +
     1			  char (jg,jb,1)*gpij (ig,if,jg,ind_here,1)
370		CONTINUE					! End jb
		wij_av	= wij_av + wij_here
380	      CONTINUE					! End if
	      wij (iz,1,ig,1,jg)	= 0.
	      wij (iz,1,ig,2,jg)	= 0.
	      wij (iz,2,ig,1,jg)	= 0.
	      wij (iz,2,ig,2,jg)	= 0.
	      IF        (group (ig) .EQ. 'ACID') THEN
		IF      (group (jg) .EQ. 'ACID') THEN
		  wij (iz,1,ig,1,jg)	= wij_av / FLOAT (if_max)
		ELSE IF (group (jg) .EQ. 'BASE') THEN
		  wij (iz,1,ig,2,jg)	= wij_av / FLOAT (if_max)
		ELSE
		  GOTO 910
		END IF
	      ELSE IF   (group (ig) .EQ. 'BASE') THEN
		IF      (group (jg) .EQ. 'ACID') THEN
		  wij (iz,2,ig,1,jg)	= wij_av / FLOAT (if_max)
		ELSE IF (group (jg) .EQ. 'BASE') THEN
		  wij (iz,2,ig,2,jg)	= wij_av / FLOAT (if_max)
		ELSE
		  GOTO 910
		END IF
	      ELSE
		GOTO 910
	      END IF
400	    CONTINUE						! End jg
410	  CONTINUE						! End ig

	END IF							! .not.partials

C And now for the more complicated partials bit.

	IF (partials) THEN

C partials - se

	  DO 460 ig			= 1, n_gps
	    DO 450 i_Q_here		= 2, 4
	      se_diff_prtl (i_Q_here)	= 0.
	      IF (extra_runs) THEN
		if_max			= 3
	      ELSE
		if_max			= 1
	      END IF
	      DO 440 if			= 1, if_max
		se_1			= 0.
		se_2			= 0.
		DO 430 ib		= 1, igps (ig,i_Q_here)
		  se_1		= se_1 +
     1		    char (ig,ib,i_Q_here)*se (ig,1,if,ib,i_Q_here)
		  se_2		= se_2 +
     1		    char (ig,ib,i_Q_here)*se (ig,2,if,ib,i_Q_here)
430		CONTINUE					! End ib
		se_diff_prtl (i_Q_here)	= se_diff_prtl (i_Q_here) +
     1					   se_1 - se_2
440	      CONTINUE						! End if
C ?? self-energy divide by 2
	      se_diff_prtl (i_Q_here)	= se_diff_prtl (i_Q_here) /
     1					  (2.*FLOAT (if_max))
450	    CONTINUE						! End i_Q_here
	    IF      (group (ig) .EQ. 'ACID') THEN
	      se_diff (iz,1,ig)	= se_diff_prtl (2)
	      se_diff (iz,2,ig)	= (se_diff_prtl (3) +
     1				   se_diff_prtl (4) ) / 2.
	    ELSE IF (group (ig) .EQ. 'BASE') THEN
	      se_diff (iz,1,ig)	= (se_diff_prtl (3) +
     1				   se_diff_prtl (4) ) / 2.
	      se_diff (iz,2,ig)	= se_diff_prtl (2)
	    ELSE
	      GOTO 910
	    END IF
460	  CONTINUE						! End ig

C partials - fix

	  DO 500 ig			= 1, n_gps
	    DO 490 i_Q_here		= 2, 4
	      fix_diff_prtl (i_Q_here)	= 0.
	      IF (extra_runs) THEN
		if_max			= 3
	      ELSE
		if_max			= 1
	      END IF
	      DO 480 if			= 1, if_max
		fix_1			= fix (ig,1,if,i_Q_here)
		fix_2			= fix (ig,2,if,i_Q_here)
		fix_diff_prtl (i_Q_here) = fix_diff_prtl (i_Q_here) +
     1					   fix_1 - fix_2
480	      CONTINUE						! End if
	      fix_diff_prtl (i_Q_here)	= fix_diff_prtl (i_Q_here) /
     1					  (FLOAT (if_max))
490	    CONTINUE						! End i_Q_here
	    IF      (group (ig) .EQ. 'ACID') THEN
	      fix_diff (iz,1,ig)	= fix_diff_prtl (2)
	      fix_diff (iz,2,ig)	= (fix_diff_prtl (3) +
     1					   fix_diff_prtl (4) ) / 2.
	    ELSE IF (group (ig) .EQ. 'BASE') THEN
	      fix_diff (iz,1,ig)	= (fix_diff_prtl (3) +
     1					   fix_diff_prtl (4) ) / 2.
	      fix_diff (iz,2,ig)	= fix_diff_prtl (2)
	    ELSE
	      GOTO 910
	    END IF
500	  CONTINUE						! End ig

C partials - wij - where we have the option of using 2 i_Q_here counters
C		   to use the proper charged forms in ionisable interactions.
C		   Look back to fd_manager for the origin of i_Q_here's
C		   If partial_ijs = F, then we just use chr_unit sets for the
C		   interpolated potential and the charge locations - as for
C		   the wij's with partials = F.

	  DO 600 ig			= 1, n_gps
	    DO 590 jg			= 1, n_gps
	      IF (jg .EQ. ig) GOTO 590

	      IF (partial_ijs) THEN
		IF (extra_runs) THEN
		  if_max		= 3
		ELSE
		  if_max		= 1
		END IF
		DO 560 i_Q		= 2, 4
		  DO 550 j_Q		= 2, 4
		    wij_prtl2 (i_Q,j_Q)	= 0.
		    DO 540 if		= 1, if_max
		      DO 530 jb		= 1, igps (jg,j_Q)
			ind_here	= ind_xyz (jg,jb,j_Q)
			IF (ind_here.LT.1.OR.ind_here.GT.10) GOTO 970
			wij_prtl2 (i_Q,j_Q) = wij_prtl2 (i_Q,j_Q) +
     1		        char (jg,jb,j_Q)*gpij (ig,if,jg,ind_here,i_Q)
530		      CONTINUE					! End jb
540		    CONTINUE					! End if
		    wij_prtl2 (i_Q,j_Q)	= wij_prtl2 (i_Q,j_Q) /
     1					  (FLOAT (if_max))
550		  CONTINUE					! End j_Q
560		CONTINUE					! End i_Q
		wij_char_char = wij_prtl2 (2,2)
		wij_neut_neut = (wij_prtl2 (3,3) + wij_prtl2 (4,4) +
     1				 wij_prtl2 (3,4) + wij_prtl2 (4,3))/4.
		wij_char_neut = (wij_prtl2 (2,3) + wij_prtl2 (2,4))/2.
		wij_neut_char = (wij_prtl2 (3,2) + wij_prtl2 (4,2))/2.
		IF        (group (ig) .EQ. 'ACID') THEN
		  IF      (group (jg) .EQ. 'ACID') THEN
		    wij (iz,1,ig,1,jg)	= wij_char_char
		    wij (iz,1,ig,2,jg)	= wij_char_neut
		    wij (iz,2,ig,1,jg)	= wij_neut_char
		    wij (iz,2,ig,2,jg)	= wij_neut_neut
		  ELSE IF (group (jg) .EQ. 'BASE') THEN
		    wij (iz,1,ig,1,jg)	= wij_char_neut
		    wij (iz,1,ig,2,jg)	= wij_char_char
		    wij (iz,2,ig,1,jg)	= wij_neut_neut
		    wij (iz,2,ig,2,jg)	= wij_neut_char
		  ELSE
		    GOTO 910
		  END IF
		ELSE IF   (group (ig) .EQ. 'BASE') THEN
		  IF      (group (jg) .EQ. 'ACID') THEN
		    wij (iz,1,ig,1,jg)	= wij_neut_char
		    wij (iz,1,ig,2,jg)	= wij_neut_neut
		    wij (iz,2,ig,1,jg)	= wij_char_char
		    wij (iz,2,ig,2,jg)	= wij_char_neut
		  ELSE IF (group (jg) .EQ. 'BASE') THEN
		    wij (iz,1,ig,1,jg)	= wij_neut_neut
		    wij (iz,1,ig,2,jg)	= wij_neut_char
		    wij (iz,2,ig,1,jg)	= wij_char_neut
		    wij (iz,2,ig,2,jg)	= wij_char_char
		  ELSE
		    GOTO 910
		  END IF
		ELSE
		  GOTO 910
		END IF
	      ELSE						! prtl_ijs=F
		wij_prtl		= 0.
		IF (extra_runs) THEN
		  if_max		= 3
		ELSE
		  if_max		= 1
		END IF
		DO 580 if		= 1, if_max
		  DO 570 jb		= 1, igps (jg,1)
		    ind_here		= ind_xyz (jg,jb,1)
		    IF (ind_here.LT.1.OR.ind_here.GT.10) GOTO 970
		    wij_prtl		= wij_prtl +
     1		    char (jg,jb,1)*gpij (ig,if,jg,ind_here,1)
570		  CONTINUE					! End jb
580		CONTINUE					! End if
		wij_prtl		= wij_prtl / (FLOAT (if_max))
		wij (iz,1,ig,1,jg)	= 0.
		wij (iz,1,ig,2,jg)	= 0.
		wij (iz,2,ig,1,jg)	= 0.
		wij (iz,2,ig,2,jg)	= 0.
		IF        (group (ig) .EQ. 'ACID') THEN
		  IF      (group (jg) .EQ. 'ACID') THEN
		    wij (iz,1,ig,1,jg)	= wij_prtl
		  ELSE IF (group (jg) .EQ. 'BASE') THEN
		    wij (iz,1,ig,2,jg)	= wij_prtl
		  ELSE
		    GOTO 910
		  END IF
		ELSE IF   (group (ig) .EQ. 'BASE') THEN
		  IF      (group (jg) .EQ. 'ACID') THEN
		    wij (iz,2,ig,1,jg)	= wij_prtl
		  ELSE IF (group (jg) .EQ. 'BASE') THEN
		    wij (iz,2,ig,2,jg)	= wij_prtl
		  ELSE
		    GOTO 910
		  END IF
		ELSE
		  GOTO 910
		END IF
	      END IF						! partial_ijs

590	    CONTINUE						! End jg
600	  CONTINUE						! End ig

	END IF							! partials

C Since we seem to have stuck Vf processing for Vf_mod here, we will also do
C the Vf-based calculation of whether DH is allowed in an FD/DH combo.
C Current calcn looks at amount of shell filled on going from iso aa to bg.
C OR the OTHER option looks through the result of a sc_freedom file, which
C should give us a bit more oomph than just a Vf-based calculation.
C dh_choice ('sc_freedom' or 'volumefrac') controls this option.  For the
C sc_freedom calculation, ionisables not found have allowed DH ***CAREFUL***.

	IF ((fd_dh.EQ.'fdplusdh') .AND. (iz.EQ.1)) THEN
	  IF      (dh_choice .EQ. 'volumefrac') THEN
	    WRITE (2,2160)
	  ELSE IF (dh_choice .EQ. 'sc_freedom') THEN
	    WRITE (2,2162)
	  ELSE
	    STOP 'dh_choice'
	  END IF

	  IF (fix_fd) THEN
	    WRITE (2,*) 'CHECK the following COMBO aas for NO_DH'
	    DO 603 ialt		= 1, nalt
	      WRITE (2,2470) chn_alt(ialt), res_alt(ialt),
     1			     nres_alt(ialt)
603	    CONTINUE						! End ialt
	    WRITE (2,*)
	  END IF

	  DO 610 ig		= 1, n_gps
	    IF     (dh_choice .EQ. 'volumefrac') THEN
	      test_frac		= Vf (ig,3) / Vf (ig,2)
	      IF ((test_frac.LT.0.).OR.(test_frac.GT.1.0)) STOP't_frac'
	      IF (test_frac .LT. 0.5) THEN
	        dh_allowed (ig)	= .FALSE.
	        WRITE (2,2180) ig, rgps(ig), cgps(ig), igps_nres(ig),
     1			       'DISALLOWED'
	      ELSE
	        dh_allowed (ig)	= .TRUE.
	        WRITE (2,2180) ig, rgps(ig), cgps(ig), igps_nres(ig),
     1			       '   allowed'
	      END IF
	    ELSE IF (dh_choice .EQ. 'sc_freedom') THEN
	     dh_allowed (ig)	= .TRUE.
C??	     dh_allowed (ig)	= .FALSE.
	     IF (n_scf .NE. 0) THEN
	      DO 606 i_scf	= 1, n_scf
		IF ((rgps(ig)		.EQ. scf_res(i_scf)).AND.
     1		    (igps_nres(ig)	.EQ. scf_nres(i_scf)) .AND.
     2		    (cgps(ig)		.EQ. scf_chain(i_scf))) THEN
		  IF (scf(i_scf)) THEN
		    dh_allowed (ig) = .TRUE.
		    WRITE(2,2182)ig, rgps(ig), cgps(ig), igps_nres(ig),
     1				 '   allowed'
		  ELSE
		    dh_allowed (ig) = .FALSE.
		    IF (fix_fd .AND. scf_alt_over(i_scf)) THEN
		      WRITE(2,2186)ig,rgps(ig),cgps(ig),igps_nres(ig),
     1				   'DISALLOWED'
		    ELSE
		      WRITE(2,2182)ig,rgps(ig),cgps(ig),igps_nres(ig),
     1				   'DISALLOWED'
		    END IF
		  END IF
		  GOTO 610
		END IF
606	      CONTINUE						! End i_scf
	     END IF
	     IF      (rgps(ig).EQ.'SBS ') THEN
	      dh_allowed (ig) = .FALSE.
	      WRITE(2,2183)ig, rgps(ig), cgps(ig), igps_nres(ig),
     1			   'DISALLOWED'
	     ELSE IF (rgps(ig).EQ.'K+  ') THEN
	      dh_allowed (ig) = .FALSE.
	      WRITE(2,2183)ig, rgps(ig), cgps(ig), igps_nres(ig),
     1			   'DISALLOWED'
	     ELSE
	      WRITE (2,2184) ig, rgps(ig), cgps(ig), igps_nres(ig),
     1			     '   allowed'
	     END IF
	    END IF
610	  CONTINUE						! End ig
	END IF

C For fd i/p files only we have two se(/fx) update mechanisms.  The first,
C which we hope to use routinely, is the Vf-based TdelS modn.  The second
C is an option for a further specific se/fx update file which modifies values.
C ?? The shell values are currently taken as 450 e.mV (single site) or 150 e.mV
C ?? (double site), which were derived *LOOSELY* ONLY FOR DIEL_P=4. *UPDATE*
C Nov.99 UPDATE - the shells are now derived from notional Ns values from pK
C Nov.99 UPDATE - fitting - Arg is unclear, His is messy, terminii unclear.

	IF ((fd_dh .NE. 'dh_only ') .AND. (iz .EQ. 1)) THEN
	  IF (Vf_mod) THEN
	    WRITE (2,2190)
	    WRITE (2,2195)
	    DO 620 ig		= 1, n_gps
	      shell_frac	= Vf (ig,2) - Vf (ig,1)
	      IF (shell_frac .LT. 0.) THEN
C??		IF (shell_frac .LT. -0.01) THEN
		IF (shell_frac .LT. -0.10) THEN
		  STOP 'shell_frac .lt. -0.10'
		ELSE
		  shell_frac	= 0.0
		END IF
	      END IF
	      shell_found	= .FALSE.
	      IF ((pKint(ig).EQ.4.00) .AND. (rgps(ig).EQ.'ASP ')) THEN
		shell_here	= 135.
		shell_found	= .TRUE.
	      END IF
	      IF ((pKint(ig).EQ.4.40) .AND. (rgps(ig).EQ.'GLU ')) THEN
		shell_here	= 135.
		shell_found	= .TRUE.
	      END IF
	      IF ((pKint(ig).EQ.6.30) .AND. (rgps(ig).EQ.'HIS ')) THEN
Caug03		shell_here	= 75.
		shell_here	= 135.
		shell_found	= .TRUE.
	      END IF
	      IF ((pKint(ig).EQ.10.40).AND. (rgps(ig).EQ.'LYS ')) THEN
		shell_here	= 75.
		shell_found	= .TRUE.
	      END IF
	      IF ((pKint(ig).EQ.7.00).AND. (rgps(ig).EQ.'SBS ')) THEN
		shell_here	= 360.
		shell_found	= .TRUE.
	      END IF
	      IF ((pKint(ig).EQ.30.0).AND. (rgps(ig).EQ.'K+  ')) THEN
		shell_here	= 360.
		shell_found	= .TRUE.
	      END IF
	      IF ((pKint(ig).EQ.12.00).AND. (rgps(ig).EQ.'ARG ')) THEN
Caug03		shell_here	= 75.
		shell_here	= 135.
		shell_found	= .TRUE.
	      END IF
	      IF ((pKint(ig).EQ.8.30) .AND. (rgps(ig).EQ.'CYS ')) THEN
Capr05		shell_here	= 410.
		shell_here	= 360.
		shell_found	= .TRUE.
	      END IF
	      IF ((pKint(ig).EQ.10.20).AND. (rgps(ig).EQ.'TYR ')) THEN
		shell_here	= 75.
		shell_found	= .TRUE.
	      END IF
	      IF (pKint (ig) .EQ. 7.50) THEN
		shell_here	= 75.
		shell_found	= .TRUE.
	      END IF
	      IF (pKint (ig) .EQ. 3.80) THEN
		shell_here	= 135.
		shell_found	= .TRUE.
	      END IF
C??	      IF (.NOT. shell_found) STOP 'shell_found'
C?? cludge this to a general value - nasty!
	      IF (.NOT. shell_found) THEN
		shell_here	= 75.
		WRITE (2,2198) rgps(ig), pKint (ig)
	      END IF

	      se_mod		= shell_here*shell_frac
	      IF      (group (ig) .EQ. 'ACID') THEN
		se_diff_old	= se_diff (iz,1,ig)
		se_diff (iz,1,ig) = se_diff (iz,1,ig) - se_mod
	      ELSE IF (group (ig) .EQ. 'BASE') THEN
		se_diff_old	= se_diff (iz,2,ig)
		se_diff (iz,2,ig) = se_diff (iz,2,ig) - se_mod
	      ELSE
		GOTO 910
	      END IF
	      WRITE (2,2200) ig, rgps(ig), cgps(ig), igps_nres(ig),
     1			     shell_here, shell_frac, se_mod,
     2			     se_diff_old, se_diff_old-se_mod
620	    CONTINUE						! End ig
	    WRITE (2,*)
	  END IF

C OCT.2001 - stop here until we update this i/p with chain info.
C OCT.2001 - simply put in an A1 chain variable to compare with cgps.
	IF (other_upd) STOP 'get chain info from upd file'

	  IF (other_upd) THEN
	    OPEN (UNIT=3, NAME=other_file, TYPE='OLD')
	    READ (3,*)
	    READ (3,*)
	    READ (3,*) percent, val_100
	    READ (3,*) n_update
	    WRITE (2,1260) n_update
	    WRITE (2,1300)
	    i_update			= 0
	    DO 650 n			= 1, n_update
	      READ (3,1100,ERR=920) nres, res, code, ind1, val_new,
     1				    val_new2
	      DO 630 ig			= 1, n_gps
	        IF((nres.EQ.igps_nres(ig)).AND.(res.EQ.rgps(ig)).AND.
     1		   (chain.EQ.cgps(ig)))THEN
		  IF	(code .EQ. 'SE  ') THEN
		    val_old		= se_diff (iz,ind1,ig)
		    IF (percent) THEN
		      val_new		= val_100 * (val_new/100.)
		    ELSE
		      val_new		= 0.
		    END IF
		    se_diff(iz,ind1,ig)	= val_old + val_new + val_new2
		    i_update		= i_update + 1
		    WRITE (2,1400) nres, res, ig, se_diff(iz,ind1,ig),
     1				   val_old
		  ELSE IF (code .EQ. 'FIX ') THEN
		    val_old		= fix_diff (iz,ind1,ig)
		    IF (percent) THEN
		      val_new		= val_100 * (val_new/100.)
		    ELSE
		      val_new		= 0.
		    END IF
		   fix_diff(iz,ind1,ig) = val_old + val_new + val_new2
		   i_update		= i_update + 1
		   WRITE (2,1500) nres, res, ig, fix_diff(iz,ind1,ig),
     1				  val_old
		  ELSE
		    GOTO 940
		  END IF
		  GOTO 650
	        END IF
630	      CONTINUE						! End ig
	      GOTO 930
650	    CONTINUE						! End n
	    WRITE (2,1600) i_update
	    CLOSE (UNIT=3)
	  END IF
	END IF

C Convert the e.mV energies to kT per molecule, and assign acid/base.

	bolt		= 1.38062 E-23
C mod Jan 2000 temp_K i/p	temp		= 300.
	elec		= 1.60219 E-19
	enat		= 2.718282
	avagad		= 6.02217 E23
	nat10		= ALOG (10.)

C Get 1 k.T and 1 e.mV into kJ/molecule.

	one_kT		= bolt * temp_K
	one_emV		= elec * 1.E-3
	convert		= one_emV / one_kT

	DO 700 ig		= 1, n_gps
	  DO 690 ip		= 1, 2
	    se_diff (iz,ip,ig)	= convert * se_diff (iz,ip,ig)
	    fix_diff (iz,ip,ig)	= convert * fix_diff (iz,ip,ig)
	    DO 680 jg		= 1, n_gps
	      DO 670 jp		= 1, 2
		wij(iz,ip,ig,jp,jg) = convert*wij(iz,ip,ig,jp,jg)
670	      CONTINUE						! End jp
680	    CONTINUE						! End jg
690	  CONTINUE						! End ip
700	CONTINUE						! End ig

C Make the Wij array symmetric by averaging across the diagonal.
C If we are using partial_ijs, then we need to match all equivalent slots.
C For partial_ij's we'll probably get some quite large symm_diff values,
C due to grid errors.  We'll only record those wher the average is
C larger than 0.2 kT.
C ?? We can use list_data to judge the ij/ji mismatch errors.

C %% partial_ijs warning - we were distracted when we programmed this!

	symm_diff_top		= 0.
	IF (partial_ijs) THEN
	  DO 760 ig		= 2, n_gps
	    DO 740 jg		= 1, ig-1
	      DO 720 ip			= 1, 2
		DO 720 jp		= 1, 2
		  wij_here		= wij (iz,ip,ig,jp,jg)
		  wji_here		= wij (iz,jp,jg,ip,ig)
		  wij_average		= (wij_here + wji_here) / 2.
		  wij (iz,ip,ig,jp,jg)	= wij_average
		  wij (iz,jp,jg,ip,ig)	= wij_average
		  wij_move_1		= wij_here - wij_average
		  wij_move_2		= wji_here - wij_average
		  IF (ABS (wij_move_1) .GT. 0.2 .OR.
     1		      ABS (wij_move_2) .GT. 0.2) THEN
		   IF (wij_average .NE. 0.) THEN
		    symm_diff	= (wij_here - wji_here) / wij_average
		   ELSE
		    symm_diff	= 0.
		   END IF
		    symm_diff		= ABS (symm_diff)
		    IF (symm_diff .GT. symm_diff_top)
     1				symm_diff_top=symm_diff

C %% curtly
C %%	IF (symm_diff.GT.1.) WRITE (6,1155) ig,jg, wij_here, wji_here
C %%1155  FORMAT (' ','sym_diff.gt.1 for i,j, wij,wji = ',2I3,2E12.4)
C %% curtly

		  END IF					! wij_av/.2
720	      CONTINUE						! End jp,ip
740	    CONTINUE						! End jg
760	  CONTINUE						! End ig
	ELSE							! not prtl_ijs
	  DO 800 ig		= 2, n_gps
	    IF        (group (ig) .EQ. 'ACID') THEN
	      ip		= 1
	    ELSE IF   (group (ig) .EQ. 'BASE') THEN
	      ip		= 2
	    ELSE
	      GOTO 910
	    END IF
	    DO 780 jg		= 1, ig-1
	      IF      (group (jg) .EQ. 'ACID') THEN
		jp		= 1
	      ELSE IF (group (jg) .EQ. 'BASE') THEN
		jp		= 2
	      ELSE
		GOTO 910
	      END IF
	      wij_here		= wij (iz,ip,ig,jp,jg)
	      wji_here		= wij (iz,jp,jg,ip,ig)
	      wij_average	= (wij_here + wji_here) / 2.
	      wij (iz,ip,ig,jp,jg)	= wij_average
	      wij (iz,jp,jg,ip,ig)	= wij_average
	     IF (wij_average .NE. 0.) THEN
	      symm_diff		= (wij_here - wji_here) / wij_average
	     ELSE
	      symm_diff		= 0.
	     END IF
	      symm_diff		= ABS (symm_diff)
	      IF (symm_diff.GT.symm_diff_top) symm_diff_top=symm_diff
780	    CONTINUE						! End jg
800	  CONTINUE						! End ig
	END IF							! prtl_ijs

C Now we have got the wij values, repeat the coupling analysis we may do
C (if mc) later on - here to propagate NO_DH gps, if couple_nodh is set.

	IF ((fd_dh.EQ.'fdplusdh') .AND. (iz.EQ.1)) THEN
	  IF (couple_nodh) THEN
	    CALL couple_scf (couple_kT)
	  END IF
	END IF

	RETURN

900	WRITE (6,9000)
	CALL	EXIT

910	WRITE (6,9100)
	CALL	EXIT

920	WRITE (6,9200)
	CALL	EXIT

930	WRITE (6,9300)
	CALL	EXIT

940	WRITE (6,9400)
	CALL	EXIT

945	WRITE (6,9450)
	CALL	EXIT

950	WRITE (6,9500)
	CALL	EXIT

960	WRITE (6,9600)
	CALL	EXIT

970	WRITE (6,9700)
	CALL	EXIT
	END


	SUBROUTINE	calc_rs (pH_here, n_red_here,n_states_here,
C	**********	*******
     1				 frei_en_N, frei_en_D)

C Calculate pK's according to the reduced site (Bashford and Karplus) model.
C Our standard state is with all groups unprotonated, and we can get some
C pretty favourable energies - do 2 passes of the configurations for pH_here,
C getting the moast favourable energy from the first and processing
C probabalities on the second.
C ?? - is this a sensibel way of doing things?

	CHARACTER*8	method
	REAL		se_diff (2,2,355), fix_diff (2,2,355),
     1			wij (2,2,355,2,355), gps_sum (355,4)
	REAL		av_gp_prot (355),
     1			pK_int (355), nat10,
     2			av_gp_dh (355), av_gp_intE (355),
     3			intE (355), av_gp_wij (355,355)
	INTEGER		igps (355,4), red_ind (30), prot_ind (355),
     1			igps_nres (355), nq_gps (4)
	CHARACTER*2	meth_ind (355)
	CHARACTER*4	gps_type (355), group (355), rgps (355),
     1			status (355)
	CHARACTER*1	cgps (355)
	CHARACTER*8	fd_dh
	CHARACTER*80	mol_label
	LOGICAL*4	bit_test, bit_test1, bit_test2
	CHARACTER*80	other_file, fd_file, dh_file
	LOGICAL		Vf_mod, other_upd, partials, partial_ijs,
     1			dh_allowed (355)

	COMMON	/constants/	bolt, elec, enat, avagad, nat10
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				dh_allowed, cgps
	COMMON	/std_energy/	group, pK_int, status
	COMMON	/params/	pH_low, pH_top, n_pH, pH_div, method,
     1				red_limit,other_upd,other_file,Vf_mod,
     2				partials, partial_ijs, couple_kT,
     3				mc_steps, pH_fix_mc, fix_mc, temp_K
	COMMON	/interact/	se_diff, fix_diff, wij
	COMMON	/reduced/	n_red, n_states, red_ind
	COMMON	/this_pH/	av_energy, av_prot, av_gp_prot,
     1				av_prot_iso, av_energy_iso, av_gp_dh,
     2				av_gp_intE, av_gp_wij
	COMMON	/doubleup/	fd_dh, i_read, fd_file, dh_file

9000	FORMAT (' *** prot_ind inconsistency in calc_rs')
9100	FORMAT (' *** status inconsistency in calc_rs')
9200	FORMAT (' *** prot_ind set wrong in calc_rs')
9300	FORMAT (' *** i_pass=2 and getting lower than energy_fav_top')

C ----------------------------------------------------------------------------
C Using		(Fprot/Funprot) = 10**(pK-pH)		(true for acid/base)
C With no electrostatic pertubation (_zero), then pK = pK_int
C
C And equating	(Fp/Fu)_zero	= 10**(pK_int-pH)	to
C		(Fp/Fu)_zero	= e**(-del_Gp_zero) / e**(-del_Gu_zero)
C gives		del_Gp_zero	= del_Gu_zero - 2.303*(pK_int-pH)
C
C And if we take the fully unprotonated molecule as the standard state, then
C a general protonation state molecule energy =
C		sum over del_Gu_zero (standard state energies) = ZERO
C	+	sum over [-2.303*(pK_int-pH)] terms for those grps protonated
C	+	the electrostatic energy differenced (isolated aa/protein)
C
C And then to get the energy difference relative to the system of isolated
C aa's, we have to calculate the mean energy of the free solution state,
C which models the denatured protein.
C
C The "electrostatic Hamiltonian" difference between isolated aa's and the
C protein system is given by:
C
C Electrostatic energy =
C		single sum over se_diff (relevant u or p slot)
C	+	single sum over fix_diff (relevant u or p slot)
C	+	(1/2) * double sum over wij (relevant u or p slots)
C ----------------------------------------------------------------------------
C The above gives the ?free? energy of a particular protonation configuration
C relative to the standard (totally unprotonated) state.
C A Boltzmann sum is then used to work out the average of any particular
C quantity, x, which has value x_s in state (s) with energy del_G_s, and
C a normalised probability of p_s_norm, and unnormalised p_s.
C Then:
C		p_s	= e**(-del_G_s)
C		p_s_norm = p_s / [sum over states of p_s]
C		<x>	= sum over states (s) of {x_s * p_s_norm}
C ie.		<x>	= [sum over s of {x_s * p_s}] / [sum over s of p_s]
C And
C This can be used for x = overall charge or overall energy or
C for individual ionisable group charge - so that we can get pK's.
C ----------------------------------------------------------------------------
C And using the partition function, we can get the free energy (units of kT)
C with:
C		free energy = -ln (Z) = -ln (sum of probs)
C
C where we need to add back our '-70' normlsn (i.e. plus (energy_fav_top+70))
C And we realise that the <x> with the electrostatic energy Hamiltonian is
C the expectation value of the internal (not free) energy.
C
C We can also evaluate the free energy of the Native relative to the
C Denatured state as (relative to a fixed point pH) with:
C
C		d(free energy_ND)/d(pH) = 2.303 (Q_D - Q_N)	(in kT units)
C ----------------------------------------------------------------------------

C If 'fd+dh ' then we will allow this pk_calc arm, so that we can look at
C small numbers of groups analytically, but we will not faff around with the
C reduce sites mechanism - since n_states goes to ntothe4, n>12 won't work.
C This whole I*4 method wil break down outside of 2E31-ish - so we will put
C a stop on n_gps > 14 for the 'fdplusdh' option in reduce_sites.  Of course,
C we don't need an energy fixing value from rs - just do the mc calcn
C anyhow - the whole scale is arbitrary.
C APRIL 2004 - WELL YES WE SHOULD FAFF - CHECK THIS AND PUT IT IN
C MAY 05 - WELL - ACTUALLY - shouldn't faff, since even if protonation state
C MAY 05 - is sorted, we still have to sample FD/DH, which is comp problem.

Cmay05	IF (fd_dh .EQ. 'fdplusdh') THEN
Cmay05	  IF (n_gps .GT. 12) THEN
Cmay05	    CALL	reduce_sites (pH_here)
Cmay05	    n_red_here		= n_red
Cmay05	  ELSE
Cmay05	    n_states		= 1
Cmay05	    DO 140 ig		= 1, n_gps
Cmay05	      n_states		= n_states*4
Cmay05140	    CONTINUE				! End ig
Cmay05	    n_red_here		= n_gps
Cmay05	  END IF
Cmay05	ELSE
Cmay05	  CALL	reduce_sites (pH_here)
Cmay05	  n_red_here		= n_red
Cmay05	END IF

	IF (fd_dh .EQ. 'fdplusdh') THEN
	  n_states		= 1
	  IF (n_gps .GT. 14) STOP '14/rs/fdplusdh'
	  DO 140 ig		= 1, n_gps
	    n_states		= n_states*4
140	  CONTINUE				! End ig
	  n_red_here		= n_gps
	ELSE
	  CALL	reduce_sites (pH_here)
	  n_red_here		= n_red
	END IF

	n_states_here		= n_states

	prob_s_tot		= 0.
	av_energy		= 0.
	av_prot			= 0.
	DO 160 ig		= 1, n_gps
	  av_gp_prot (ig)	= 0.
	  av_gp_intE (ig)	= 0.
	  IF (fd_dh .EQ. 'fdplusdh') THEN
	    av_gp_dh (ig)	= 0.
	  END IF
160	CONTINUE						! End ig
	energy_fav_top		= 9999.

C Now cycle through states using bit testing, using bit at 1 to mean
C protonated (slot 2), and bit at 0 - unprotonated (slot 1).
C For fd+dh, we also use bit testing for fd or dh.
C Remember, we are actually cycling through twice.

	DO 700 i_pass		= 1, 2

	  DO 600 is		= 1, n_states

	    DO 180 ig		= 1, n_gps
	      prot_ind (ig)	= 999
	      IF (fd_dh .EQ. 'fdplusdh') meth_ind (ig) = '  '
180	    CONTINUE						! End ig

	    IF (fd_dh .EQ. 'fdplusdh') THEN
	      DO 190 ig		= 1, n_gps
		i_bit1		= 2*ig-2
		i_bit2		= 2*ig-1
Clnx		bit_test1	= BJTEST (is,i_bit1)
Clnx		bit_test2	= BJTEST (is,i_bit2)
		bit_test1	= BTEST (is,i_bit1)
		bit_test2	= BTEST (is,i_bit2)
		IF (bit_test1) THEN
		  prot_ind (ig)	= 2
		ELSE
		  prot_ind (ig)	= 1
		END IF
		IF (bit_test2) THEN
		  meth_ind (ig)	= 'FD'
		ELSE
		  IF (dh_allowed (ig)) THEN
		    meth_ind (ig) = 'DH'
		  ELSE
		    meth_ind (ig) = 'FD'
		  END IF
		END IF
190	      CONTINUE						! End ig
	    ELSE
	      IF (n_red .NE. 0) THEN
		DO 200 ir	= 1, n_red
		  ig		= red_ind (ir)
		  i_bit		= ir - 1
Clnx		  bit_test	= BJTEST (is,i_bit)
		  bit_test	= BTEST (is,i_bit)
		  IF (bit_test) THEN
		    prot_ind (ig)	= 2
		  ELSE
		    prot_ind (ig)	= 1
		  END IF
200		CONTINUE					! End ir
	      END IF
	    END IF

	    DO 300 ig		= 1, n_gps
	      IF (fd_dh .EQ. 'fdplusdh') THEN
		IF ((prot_ind (ig) .NE. 1) .AND.
     1		    (prot_ind (ig) .NE. 2)) STOP 'prot_ind/fd+dh '
		IF ((meth_ind (ig) .NE. 'FD') .AND.
     1		    (meth_ind (ig) .NE. 'DH')) STOP 'meth_ind/fd+dh '
	      ELSE
		IF      (status (ig) .EQ. 'UNPR') THEN
		  IF (prot_ind (ig) .NE. 999) GOTO 900
		  prot_ind (ig)	= 1
		ELSE IF (status (ig) .EQ. 'PROT') THEN
		  IF (prot_ind (ig) .NE. 999) GOTO 900
		  prot_ind (ig)	= 2
		ELSE IF (status (ig) .EQ. 'VARY') THEN
		  IF (prot_ind (ig) .EQ. 999) GOTO 900
		ELSE
		  GOTO 910
		END IF
	      END IF
300	    CONTINUE						! End ig

	    energy_s		= 0.
	    DO 400 ig		= 1, n_gps
	      ip		= prot_ind (ig)

	      IF (fd_dh .EQ. 'fdplusdh') THEN
		IF      (meth_ind (ig) .EQ. 'FD') THEN
		  iz		= 1
		ELSE IF (meth_ind (ig) .EQ. 'DH') THEN
		  iz		= 2
		ELSE
		  STOP 'meth_ind wrong'
		END IF
	      ELSE
		iz		= 1
	      END IF

	      IF      (ip .EQ. 1) THEN
		en_self_here	= 0.
	      ELSE IF (ip .EQ. 2) THEN
		en_self_here	= - nat10 * (pK_int (ig) - pH_here)
	      ELSE
		GOTO 920
	      END IF
	      en_self_here	= en_self_here +
     1				  se_diff(iz,ip,ig)+fix_diff(iz,ip,ig)
	      en_ij_here	= 0.
	      DO 360 jg		= 1, n_gps
		IF (jg .EQ. ig) GOTO 360
		jp		= prot_ind (jg)

C It is important to maintain Wij symmetry by forcing a DH interaction if
C either i or j is dh.  But note that i or j can still FD interact with k.

		iz_ij		= 1
		IF (fd_dh .EQ. 'fdplusdh') THEN
		  IF ((meth_ind (ig) .EQ. 'DH') .OR.
     1		      (meth_ind (jg) .EQ. 'DH')) THEN
		    iz_ij	= 2
		  END IF
		END IF

		en_ij_here = en_ij_here + wij (iz_ij,ip,ig,jp,jg)
360	      CONTINUE						! End jg
	      energy_s		= energy_s +
     1				  en_self_here + en_ij_here/2.
	      intE (ig)		= en_self_here + en_ij_here/2.
400	    CONTINUE						! End ig

C This origin shift (for the probability function only) moves energy_fav_top
C to -70.. and then we'll put anything above +70. to zero probability.

	    IF (i_pass .EQ. 1) THEN
	      IF (energy_s.LT.energy_fav_top) energy_fav_top=energy_s
	    ELSE
	      IF (energy_s.LT.energy_fav_top) GOTO 930
	      energy_sp		= energy_s - energy_fav_top - 70.
	      IF (energy_sp .GT. 70.) THEN
		prob_s		= 0.
	      ELSE
		prob_s		= enat**(-energy_sp)
	      END IF
	      prob_s_tot	= prob_s_tot + prob_s
	      av_energy		= av_energy + energy_s*prob_s
	      prot_s		= 0.
	      DO 500 ig		= 1, n_gps
		gp_prot		= FLOAT (prot_ind (ig)) - 1.
		av_gp_prot (ig) = av_gp_prot (ig) + gp_prot*prob_s
		av_gp_intE (ig) = av_gp_intE (ig) +intE(ig)*prob_s
		IF (fd_dh .EQ. 'fdplusdh') THEN
		  IF      (meth_ind (ig) .EQ. 'FD') THEN
		    gp_meth	= 0.
		  ELSE IF (meth_ind (ig) .EQ. 'DH') THEN
		    gp_meth	= 1.
		  ELSE
		    STOP 'gp_meth/meth_ind'
		  END IF
		  av_gp_dh (ig)	= av_gp_dh (ig) + gp_meth*prob_s
		END IF
		prot_s		= prot_s + gp_prot
500	      CONTINUE					! End ig
	      av_prot		= av_prot + prot_s*prob_s
	    END IF

600	  CONTINUE						! End is

700	CONTINUE						! End i_pass

C Normalise all the mean quantities with sum of the Boltzmann probabilities.
C av_prot (overall) will be the mean number of protons added to the molecule
C at this pH, and av_gp_prot (ind gps) will be the mean fraction of a proton
C added to an individual group at this pH.

	av_energy		= av_energy / prob_s_tot
	av_prot			= av_prot / prob_s_tot
	DO 740 ig		= 1, n_gps
	  av_gp_prot (ig)	= av_gp_prot (ig) / prob_s_tot
	  av_gp_intE (ig)	= av_gp_intE (ig) / prob_s_tot
	  IF (fd_dh .EQ. 'fdplusdh') THEN
	    av_gp_dh (ig)	= av_gp_dh (ig) / prob_s_tot
	  END IF
740	CONTINUE						! End ig

C Store the free energy derived from the partition function (kT units),
C adding back the divergenece avoidance bit.

	frei_en_N		= -ALOG(prob_s_tot)+energy_fav_top+70.

C Get the mean energy and protonation state of the isolated aa's system.
C If fd_dh='fdplusdh' then we have 2**n_gps equivalent energies for each protn
C state in the iso aas system, so that we must add on to G of an fdonly system
C something like n_gps*ln2.

	av_prot_iso		= 0.
	av_energy_iso		= 0.
	frei_en_D		= 0.
	DO 800 ig		= 1, n_gps
	  pK_here		= pK_int (ig)
	  CALL	fractions (pK_here, pH_here, frac_p, frac_u)
	  av_prot_iso		= av_prot_iso + frac_p
	  energy_std		= - nat10 * (pK_int (ig) - pH_here)
	  av_energy_iso		= av_energy_iso + frac_p * energy_std
	  frei_en_D		= frei_en_D -
     1				  ALOG(1.+enat**(-energy_std))
800	CONTINUE						! End ig
	IF (fd_dh .EQ. 'fdplusdh') THEN
C ?? feb 2000 frei_en_D		= frei_en_D + FLOAT(n_gps)*ALOG(2.)
	  frei_en_D		= frei_en_D - FLOAT(n_gps)*ALOG(2.)
	END IF

	RETURN

900	WRITE (6,9000)
	CALL	EXIT

910	WRITE (6,9100)
	CALL	EXIT

920	WRITE (6,9200)
	CALL	EXIT

930	WRITE (6,9300)
	CALL	EXIT
	END


	SUBROUTINE	reduce_sites (pH_here)
C	**********	************

C No need to vary those ionisable groups outside the percentage limits.

	CHARACTER*8	method
	REAL		se_diff (2,2,355), fix_diff (2,2,355),
     1			wij (2,2,355,2,355), gps_sum (355,4)
	REAL		pK_int (355), nat10
	INTEGER		igps (355,4), red_ind (30), igps_nres (355),
     1			nq_gps (4)
	CHARACTER*4	gps_type (355), group (355), rgps (355),
     1			status (355)
	CHARACTER*1	cgps (355)
	CHARACTER*80	mol_label
	CHARACTER*80	other_file
	LOGICAL		Vf_mod, other_upd, partials, partial_ijs,
     1			dh_allowed (355)

	COMMON	/constants/	bolt, elec, enat, avagad, nat10
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				dh_allowed, cgps
	COMMON	/params/	pH_low, pH_top, n_pH, pH_div, method,
     1				red_limit,other_upd,other_file,Vf_mod,
     2				partials, partial_ijs, couple_kT,
     3				mc_steps, pH_fix_mc, fix_mc, temp_K
	COMMON	/interact/	se_diff, fix_diff, wij
	COMMON	/std_energy/	group, pK_int, status
	COMMON	/reduced/	n_red, n_states, red_ind

C??2000	FORMAT (/,' REDUCED_SITES active ',I3,' sites',/)

9000	FORMAT (' *** status trying to be PROT and UNPR')
9100	FORMAT (' *** more than 25 reduced sites')

C ----------------------------------------------------------------------------
C Using		(Fprot/Funprot) = 10**(pK-pH)		(true for acid/base)
C With		pK = pK_int + del_pK
C Where		del_pK is the diff between unprotonated and protonated states
C		on their transfer, isolated aa to protein - double difference

C Then		del_G transfers which are negative for favourable transfer
C		from isolated aa to protein

C Give		the correct sign of del_pK with
C		del_del_G = del_G (1/unprot) - del_G (2/prot)

C And		del_pK = del_del_G / 2.303
C With		del_del_G in kT/molecule units
C ----------------------------------------------------------------------------

C We should not be in this subroutine if fd_dh='fdplusdh'.  So iz=1 then.
C APRIL 2004 BUT WE MAY BE - if iz=1 slot is FD for FD/DH - SHOULD BE OK THEN

	iz		= 1

C In reducing the sites, for the maximal unprotonated form we take all j gps
C to be protonated (most favourable), and vice-versa for protonated form.
C First, set up the status array as UNPR, PROT or VARY.

	DO 400 ig	= 1, n_gps
	  energy_i	= se_diff (iz,1,ig) - se_diff (iz,2,ig) +
     1			  fix_diff (iz,1,ig) - fix_diff (iz,2,ig)
	  energy_ij_u	= 0.
	  energy_ij_p	= 0.
	  DO 300 jg	= 1, n_gps
	    IF (jg .EQ. ig) GOTO 300
	    energy_ij_u	= energy_ij_u +
     1			  wij (iz,1,ig,2,jg) - wij (iz,2,ig,2,jg)
	    energy_ij_p	= energy_ij_p +
     1			  wij (iz,1,ig,1,jg) - wij (iz,2,ig,1,jg)
300	  CONTINUE						! End jg
	  status (ig)	= 'VARY'
	  del_pK_u	= (energy_i + energy_ij_u) / nat10
	  del_pK_p	= (energy_i + energy_ij_p) / nat10
	  pK_here	= pK_int (ig) + del_pK_u
	  CALL	fractions (pK_here, pH_here, frac_p, frac_u)
	  test		= 100.*frac_u
	  IF (test .LT. red_limit) status (ig)	= 'PROT'
	  pK_here	= pK_int (ig) + del_pK_p
	  CALL	fractions (pK_here, pH_here, frac_p, frac_u)
	  test		= 100.*frac_p
	  IF (test .LT. red_limit) THEN
	    IF (status (ig) .EQ. 'PROT') GOTO 900
	    status (ig) = 'UNPR'
	  END IF
400	CONTINUE						! End ig

	n_red			= 0
	n_states		= 1
	DO 500 ig		= 1, n_gps
	  IF (status (ig) .EQ. 'VARY') THEN
	    n_red		= n_red + 1
	    IF (n_red .GT. 25) GOTO 910
	    red_ind (n_red)	= ig
	    n_states		= n_states * 2
	  END IF
500	CONTINUE						! End ig
C??	WRITE (2,2000) n_red

	RETURN

900	WRITE (6,9000)
	CALL	EXIT

910	WRITE (6,9100)
	CALL	EXIT
	END


	SUBROUTINE	fractions (pK_here, pH_here, frac_p, frac_u)
C	**********	*********

C Using		(Fprot/Funprot) = 10**(pK-pH)		(true for acid/base)

	frac_u		= 1. / (1. + 10.**(pK_here-pH_here))
	frac_p		= 1. - frac_u
	RETURN
	END


	SUBROUTINE	calc_mc (pH_here, frei_en_N, frei_en_D)
C	**********	*******

C Calculate protonation states according to Beroza et al.

	CHARACTER*8	method
	REAL		se_diff (2,2,355), fix_diff (2,2,355),
     1			wij (2,2,355,2,355), gps_sum (355,4)
	REAL		av_gp_prot (355),
     1			pK_int (355), nat10,
     2			en_nonij_old (355), en_nonij_new (355),
     3			en_ij_old (355,355), en_ij_new (355,355),
     4			av_gp_dh (355), av_gp_intE (355),
     5			intE (355), av_gp_wij (355,355)
	INTEGER		igps (355,4), prot_ind_old (355),
     1			igps_nres (355), nq_gps (4), pairs (400,2),
     2			prot_ind_new (355)
C ?? n_check runs over up to 2*n_gps + 2*n_prs - 1510 currently
	INTEGER		n_check (1510)
	CHARACTER*2	meth_ind_old (355), meth_ind_new (355)
	CHARACTER*4	gps_type (355), group (355), rgps (355),
     1			status (355)
	CHARACTER*1	cgps (355)
	CHARACTER*8	fd_dh
	CHARACTER*80	mol_label
	LOGICAL*4	bit_test
	CHARACTER*80	other_file, fd_file, dh_file
	LOGICAL		Vf_mod, other_upd, partials, partial_ijs,
     1			update_en, dh_allowed (355), protons,
     2			test_allowed, av_ij_write

	COMMON	/constants/	bolt, elec, enat, avagad, nat10
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				dh_allowed, cgps
	COMMON	/std_energy/	group, pK_int, status
	COMMON	/params/	pH_low, pH_top, n_pH, pH_div, method,
     1				red_limit,other_upd,other_file,Vf_mod,
     2				partials, partial_ijs, couple_kT,
     3				mc_steps, pH_fix_mc, fix_mc, temp_K
	COMMON	/interact/	se_diff, fix_diff, wij
	COMMON	/this_pH/	av_energy, av_prot, av_gp_prot,
     1				av_prot_iso, av_energy_iso, av_gp_dh,
     2				av_gp_intE, av_gp_wij
	COMMON	/pairing/	n_prs, pairs
	COMMON	/en_scale/	en_lowest
	COMMON	/doubleup/	fd_dh, i_read, fd_file, dh_file
	COMMON	/ij_matrix/	en_ij_old, av_ij_write

Clnx	DATA	iran3, iran4	/ 75319, 73591 /
	DATA	ipass_mc	/ 0 /

2000	FORMAT (/,1X,I4,' coupled pairs with couple_kT = ',F8.3)
2020	FORMAT (' ','i_pr = ',I4,' pair is ',2(I4,1X,A1,I4,1X,A4))
2040	FORMAT (/,'*** Remember first 1/4 steps not averaged over ***')
C??2100	FORMAT ('0','Out of ',I4,' gps, initial u/p   setting = ',2I4)
C??2110	FORMAT ('0','Out of ',I4,' gps, initial fd/dh setting = ',2I4)
C??2500	FORMAT (' ',10(I5,1X))
C??2600	FORMAT (' ',' no. prob tested updates vs sum prob (single
C??     1 moves) = ',2E10.4)
C??2620	FORMAT (' ',' no. prob tested updates vs sum prob (proton
C??     1 swaps) = ',2E10.4)
C??2660	FORMAT (' ','single moves-delG<0,delG>0/y,delG>0/n = ',3E10.4)
C??2680	FORMAT (' ','proton swaps-delG<0,delG>0/y,delG>0/n = ',3E10.4)
9000	FORMAT (' ','**** too many pairs (400 limit) ****')
9100	FORMAT (' ','**** ip is other than 1 or 2 ****')
9200	FORMAT (' ','**** n_here oub on return in 600 loop ****')

C For the first pass through calc_mc only ...
C Look for strongly coupled sites (magnitude of interaction larger than
C couple_kT in kT units).  The possible sites for protonation state changes
C are then the n_gps sites plus the additional pairs for proton transfer, of
C which there will be n_prs.  I don't think that we need record the u/p states
C of the coupling, because for mc switching we only need to try proton
C transfer - whatever the coupling - so we presumably will skip a pair if it
C has zero or 2 protons (during the mc procedure).
C *** NO, NOT QUITE - I THINK WE HAVE ERRORS FROM SKIPPING PAIRS - WE WILL ***
C *** TEST THE DOUBLE TRANSITION WHATEVER THE PAIR STATE - NO SKIPPING     ***

C Probably reasonable to assume that FD wijs will be higher than DH wijs, so
C that we will test FD values for pairing if fd_dh='fdplusdh' - always iz=1.

	IF ((pH_here.GT.6.1).AND.(pH_here .LT.6.9)) THEN
	  av_ij_write			= .TRUE.
	ELSE
	  av_ij_write			= .FALSE.
	END IF

C bugger
	ino = 0
	iyes = 0

	IF (ipass_mc .EQ. 0) THEN
	  n_prs				= 0
	  iz				= 1
	  DO 140 i			= 1, n_gps-1
	    DO 140 j			= i+1, n_gps
	      DO 120 m			= 1, 2
	        DO 120 n			= 1, 2
		  IF (ABS (wij (iz,m,i,n,j)) .GE. couple_kT) THEN
		    n_prs			= n_prs + 1
		    IF (n_prs .GT. 400) GOTO 900
		    pairs (n_prs,1)	= i
		    pairs (n_prs,2)	= j
		  END IF
120	      CONTINUE						! End n,m
140	  CONTINUE						! End j,i
	  WRITE (2,2000) n_prs, couple_kT
	  DO 160 i_pr	= 1, n_prs
	    i		= pairs (i_pr,1)
	    j		= pairs (i_pr,2)
	    WRITE (2,2020) i_pr, i,cgps(i),igps_nres(i),rgps(i),
     1			         j,cgps(j),igps_nres(j),rgps(j)
160	  CONTINUE
	  ipass_mc	= 1
	  WRITE (2,2040)
	END IF

C As in reduced sites calculation, we'll go through twice, to scale to the
C lowest energy.  We reset en_lowest for each different pH calculation.

	en_lowest	= 99999.

	DO 610 i_pass	= 1, 2

C Set all sites 1-n_gps to random initial protonation states.
C We are using prot_ind=1 for unprot. and 2 for prot, and we don't use status.

	ni_1		= 0
	ni_2		= 0
	DO 200 ig	= 1, n_gps
	  CALL	rand_12 (i_12)
	  prot_ind_old (ig)	= i_12
	  IF (i_12 .EQ. 1) ni_1 = ni_1 + 1
	  IF (i_12 .EQ. 2) ni_2 = ni_2 + 1
200	CONTINUE						! End ig
C??	WRITE (2,2100) n_gps, ni_1, ni_2

C For the fd/dh switch, we'll leave the meth_ind arrays at their randomly
C switched, and then incoprorated or not values, BUT we will test dh_allowed
C before each se_diff/fix_diff/wij array operation, and revert to FD here only
C if necessary.

	IF (fd_dh .EQ. 'fdplusdh') THEN
	  nm_1			= 0
	  nm_2			= 0
	  DO 210 ig		= 1, n_gps
	    CALL rand_12 (m_12)
	    IF      (m_12 .EQ. 1) THEN
	      nm_1		= nm_1 + 1
	      meth_ind_old (ig)	= 'FD'
	    ELSE IF (m_12 .EQ. 2) THEN
	      nm_2		= nm_2 + 1
	      meth_ind_old (ig)	= 'DH'
	    END IF
210	  CONTINUE						! End ig
C??	  WRITE (2,2110) n_gps, nm_1, nm_2
	END IF

C Calculate the es energy for this set of protonation states, and record the
C contribution for each group and each pair.  When we switch protonations we
C can simply update the relevant contributions - although we may (presumably)
C hit some problems with cumulative rounding errors.
C The pH/pKint contribution to en_nonij is a little confusing - I took it from
C calc_rs - I think it simply relects that all gps unprot. is our std state.

	en_total_new		= 0.
	en_total_ij		= 0.
	DO 300 ig		= 1, n_gps
	  ip			= prot_ind_old (ig)
	  IF (fd_dh .EQ. 'fdplusdh') THEN
	    IF (meth_ind_old (ig) .EQ. 'FD') THEN
	      iz		= 1
	    ELSE
	      iz		= 2
	      IF (.NOT. dh_allowed (ig)) iz = 1
	    END IF
	  ELSE
	    iz			= 1
	  END IF

C Maintain the fd+dh Wij symmetry, if required.

	  IF      (ip .EQ. 1) THEN
	    en_nonij_new (ig)	= 0. +
     1				  se_diff(iz,ip,ig)+fix_diff(iz,ip,ig)
	  ELSE IF (ip .EQ. 2) THEN
	    en_nonij_new (ig)	= -nat10 * (pK_int(ig)-pH_here) +
     1				  se_diff(iz,ip,ig)+fix_diff(iz,ip,ig)
	  ELSE
	    GOTO 910
	  END IF
	  en_total_new		= en_total_new + en_nonij_new (ig)
	  DO 280 jg		= 1, n_gps
	    IF (jg .EQ. ig) GOTO 280
	    jp			= prot_ind_old (jg)
	    IF (fd_dh .EQ. 'fdplusdh') THEN
	      iz_ij		= 1
	      IF (meth_ind_old (ig) .EQ. 'DH') THEN
		IF (dh_allowed (ig)) iz_ij = 2
	      END IF
	      IF (meth_ind_old (jg) .EQ. 'DH') THEN
		IF (dh_allowed (jg)) iz_ij = 2
	      END IF
	    ELSE
	      iz_ij		= 1
	    END IF
	    en_ij_new (ig,jg)	= wij (iz_ij,ip,ig,jp,jg)
	    en_total_ij		= en_total_ij+wij(iz_ij,ip,ig,jp,jg)
280	  CONTINUE						! End jg
300	CONTINUE						! End ig
	en_total_new		= en_total_new + en_total_ij/2.

	en_total_old		= en_total_new
	DO 320 ig		= 1, n_gps
	  en_nonij_old (ig)	= en_nonij_new (ig)
	  intE (ig)		= en_nonij_new (ig)
	  DO 320 jg		= 1, n_gps
	    IF (jg .EQ. ig) GOTO 320
	    en_ij_old (ig,jg)	= en_ij_new (ig,jg)
	    intE (ig)		= intE (ig) + en_ij_new (ig,jg) / 2.
320	CONTINUE						! End jg,ig

C Now we start the sums for the charge and energy expectation values, based
C on the reduced mc search of u/p and maybe fd/dh configuration states.

	i_moves			= 0
	Z_mc			= 0.
	av_energy		= 0.
	av_prot			= 0.
	DO 340 ig		= 1, n_gps
	  av_gp_prot (ig)	= 0.
	  av_gp_intE (ig)	= 0.
	  IF (fd_dh .EQ. 'fdplusdh') av_gp_dh (ig) = 0.
	  IF (av_ij_write) THEN
	    DO 330 jg		= 1, n_gps
	      av_gp_wij (ig,jg)	= 0.
330	    CONTINUE						! End jg
	  END IF
340	CONTINUE						! End ig
	IF (fd_dh .EQ. 'fdplusdh') THEN
	  moves_step		= 2*n_gps + 2*n_prs
	ELSE
	  moves_step		= n_gps + n_prs
	END IF
	n_total			= moves_step
	moves_total		= mc_steps*moves_step
	middlebin		= moves_step / 2
	CALL	mc_sums (en_total_old, Z_mc, prot_ind_old, i_pass,
     1			 i_moves, moves_total, meth_ind_old, intE)

C Now we go through the mc procedure.  ?? From Beroza et al., it is not clear
C to me how the coupled sites are included.  I'll just add n_prs to n_gps as the
C number of moves in each mc step - but I should check this - it could be wrong.

	DO 370 n		= 1, n_total
	  n_check (n)		= 0
370	CONTINUE						! End n
	sum_prob1		= 0.
	sum_prob2		= 0.
	sum_upd1_1		= 0.
	sum_upd1_2		= 0.
	sum_upd1_3		= 0.
	sum_upd2_1		= 0.
	sum_upd2_2		= 0.
	sum_upd2_3		= 0.
	DO 600 m		= 1, moves_total
	  i_moves		= i_moves + 1
Clnx	  CALL	rand_here (n_total, n_here)
	  CALL	rand_here (n_total, n_here, moves_total, middlebin)
	  n_check (n_here)	= n_check (n_here) + 1

	  IF (fd_dh .EQ. 'fdplusdh') THEN
	    n_here_chk		= 2*n_gps
	  ELSE
	    n_here_chk		= n_gps
	  END IF

	  IF (n_here .LE. n_here_chk) THEN

	    IF ((n_here.GE.1) .AND. (n_here.LE.n_gps)) THEN
	      ig		= n_here

	      IF (fd_dh .EQ. 'fdplusdh') THEN
		IF (meth_ind_old (ig) .EQ. 'FD') THEN
		  iz		= 1
		ELSE
		  iz		= 2
		  IF (.NOT. dh_allowed (ig)) iz = 1
		END IF
	      ELSE
		iz		= 1
	      END IF

	      IF (prot_ind_old (ig) .EQ. 1) THEN
		prot_ind_new (ig) = 2
		ip		  = 2
	        en_nonij_new (ig) = -nat10 * (pK_int(ig)-pH_here) +
     1				  se_diff(iz,ip,ig)+fix_diff(iz,ip,ig)
	      ELSE
		prot_ind_new (ig) = 1
		ip		  = 1
		en_nonij_new (ig) = 0. +
     1				  se_diff(iz,ip,ig)+fix_diff(iz,ip,ig)
	      END IF
	    ELSE IF ((n_here.GE.n_gps+1).AND.(n_here.LE.2*n_gps)) THEN
	      IF (fd_dh .NE. 'fdplusdh') STOP 'fd_dh mism1'
	      ig		= n_here - n_gps
	      ip		= prot_ind_old (ig)
	      IF (meth_ind_old (ig) .EQ. 'FD') THEN
		IF (dh_allowed (ig)) THEN
		  iz			= 2
		  meth_ind_new (ig)	= 'DH'
		ELSE

C ?? karolinska - cop out here - calculate same energy again for "FD/FD" swch.

		  iz			= 1
		  meth_ind_new (ig)	= 'FD'
		END IF
	      ELSE
		iz			= 1
		meth_ind_new (ig)	= 'FD'
	      END IF
	      IF (ip .EQ. 1) THEN
		en_nonij_new (ig) = 0. +
     1				  se_diff(iz,ip,ig)+fix_diff(iz,ip,ig)
	      ELSE
	        en_nonij_new (ig) = -nat10 * (pK_int(ig)-pH_here) +
     1				  se_diff(iz,ip,ig)+fix_diff(iz,ip,ig)
	      END IF
	    ELSE
	      GOTO 920
	    END IF

	    en_ij_inc		= 0.
	    en_ij_dec		= 0.
	    DO 420 jg		= 1, n_gps
	      IF (jg .EQ. ig) GOTO 420
	      jp		= prot_ind_old (jg)
	      iz_ij		= iz
	      IF (fd_dh .EQ. 'fdplusdh') THEN
		IF ((meth_ind_old (jg) .EQ. 'DH') .AND.
     1		    (dh_allowed (jg))) THEN
		  iz_ij		= 2
		END IF
	      END IF
	      en_ij_new (ig,jg)	= wij (iz_ij,ip,ig,jp,jg)
	      en_ij_new (jg,ig)	= wij (iz_ij,jp,jg,ip,ig)
	      en_ij_inc		= en_ij_inc +
     1				  en_ij_new(ig,jg) + en_ij_new(jg,ig)
	      en_ij_dec		= en_ij_dec +
     1				  en_ij_old(ig,jg) + en_ij_old(jg,ig)
420	    CONTINUE						! End jg
	    en_total_new	= en_total_old +
     1				  en_nonij_new(ig)-en_nonij_old(ig) +
     2				  (en_ij_inc - en_ij_dec)/2.
	    en_change		= en_total_new - en_total_old
	    IF (en_change .LE. 0.) THEN
	      update_en		= .TRUE.
	      sum_upd1_1	= sum_upd1_1 + 1.
	    ELSE
	      prob_en		= enat**(-en_change)
	      sum_prob1		= sum_prob1 + prob_en
	      CALL random_num (temp3)
C ??ran	      iran3		= 75319
Clnx	      temp3		= RAN (iran3)
Clnx	      temp3		= RAND (0)
	      IF (temp3.LT.-0.00001.OR.temp3.GE.1.00001)
     1		STOP 'random3 wrong'
	      IF (temp3 .LT. 0.) temp3 = 0.
	      IF (temp3 .GT. 1.) temp3 = 1.
	      IF (temp3 .LT. prob_en) THEN
		update_en	= .TRUE.
		sum_upd1_2	= sum_upd1_2 + 1.
	      ELSE
		update_en	= .FALSE.
		sum_upd1_3	= sum_upd1_3 + 1.
	      END IF
	    END IF
	    IF (update_en) THEN
	      IF (fd_dh .EQ. 'fdplusdh') THEN
		IF ((n_here.GE.1) .AND. (n_here.LE.n_gps)) THEN
		  prot_ind_old (ig)	= prot_ind_new (ig)
		ELSE IF ((n_here.GE.n_gps+1).AND.
     1			 (n_here.LE.2*n_gps)) THEN
		  meth_ind_old (ig)	= meth_ind_new (ig)
		ELSE
		  STOP 'n_here ?1'
		END IF
	      ELSE
		prot_ind_old (ig)	= prot_ind_new (ig)
	      END IF
	      en_total_old	= en_total_new
	      en_nonij_old (ig)	= en_nonij_new (ig)
	      intE (ig)		= en_nonij_old (ig)
	      DO 430 jg		= 1, n_gps
	        IF (jg .EQ. ig) GOTO 430
	        en_ij_old (ig,jg) = en_ij_new (ig,jg)
	        en_ij_old (jg,ig) = en_ij_new (jg,ig)
		intE (ig)	= intE (ig) + en_ij_new(ig,jg)/2.
430	      CONTINUE						! End jg
	    END IF
	    CALL mc_sums (en_total_old, Z_mc, prot_ind_old, i_pass,
     1			  i_moves, moves_total, meth_ind_old, intE)

	  ELSE

C Modified Feb.2000 - NOW we are interested in both double proton (proton
C transfer) moves AND double fd/dh jumps for coupled (interacting) groups.
C I'm really not sure how the sampling statistics work out for 2*n_prs just
C cobbled on to 2*n_gps - but let's see if it works!
C Actually it isn't quite 'cobbled' together - the various u/p,fd/dh,ipr
C analyses are randomly jumbled - which is good!
C The first n_prs band goes to proton moves, the second to fd/dh.
C We'll try to keep the code as common as possible.

C We are only interested in proton transfer here, so we skip the move if both
C pair members are either u or p.
C *** NO - WE DO NOT SKIP NOW ***
C ?? karolinska - I'm not sure about the interaction (below) of pairing and
C 'fd+dh ' either.  My logic at present is to leave as is, looking at coupled
C u/p changes, without changing fd/dh.  We assume that it will only really
C matter for fdi/fdj - where coupling could be quite large - otherwise coupling
C will be dh and presumably small.  Check the influence of coupling (by varying
C couple_kT) on the results.

C ???? FEB 2000 - WE HAVE SOME SILLY OVER-ELABORN OF meth_ind - SORT IT ????

	    IF (fd_dh .EQ. 'fdplusdh') THEN
	      i_left		= n_here - 2*n_gps
	      IF (i_left .GT. 2*n_prs) THEN
		STOP 'i_left/2*n_prs'
	      ELSE IF (i_left .GT. n_prs) THEN
		ipr		= i_left - n_prs
		protons		= .FALSE.
	      ELSE IF (i_left .GE. 1) THEN
		ipr		= i_left
		protons		= .TRUE.
	      ELSE
		STOP 'i_left lt 1'
	      END IF
	    ELSE
	      ipr		= n_here - n_gps
	      protons		= .TRUE.
	    END IF
	    IF (ipr.LT.1 .OR. ipr.GT.n_prs) GOTO 920
	    ipr1		= pairs (ipr,1)
	    ipr2		= pairs (ipr,2)

	    IF (protons) THEN

C bugger
	iyes = iyes + 1

	      ind1_old		= prot_ind_old (ipr1)
	      ind2_old		= prot_ind_old (ipr2)
	      IF      (ind1_old .EQ. 1) THEN
		IF    (ind2_old .EQ. 1) THEN
		  prot_ind_new (ipr1)	= 2
		  ind1_here	= 2
		  prot_ind_new (ipr2)	= 2
		  ind2_here	= 2
		ELSE IF (ind2_old .EQ. 2) THEN
		  prot_ind_new (ipr1)	= 2
		  ind1_here	= 2
		  prot_ind_new (ipr2)	= 1
		  ind2_here	= 1
		ELSE
		  STOP 'ind2/600 loop'
		END IF
	      ELSE IF (ind1_old .EQ. 2) THEN
		IF (ind2_old .EQ. 1) THEN
		  prot_ind_new (ipr1)	= 1
		  ind1_here	= 1
		  prot_ind_new (ipr2)	= 2
		  ind2_here	= 2
		ELSE IF (ind2_old .EQ. 2) THEN
		  prot_ind_new (ipr1)	= 1
		  ind1_here	= 1
		  prot_ind_new (ipr2)	= 1
		  ind2_here	= 1
		ELSE
		  STOP 'ind2/600 loop'
		END IF
	      ELSE
		STOP 'ind1/600 loop'
	      END IF
	      IF (fd_dh .EQ. 'fdplusdh') THEN
		DO 480 ii		= 1, n_gps
		  IF ((meth_ind_old (ii) .NE. 'FD') .AND.
     1		      (meth_ind_old (ii) .NE. 'DH'))STOP'meth_ind/ii'
480		CONTINUE					! End ii
		IF (meth_ind_old (ipr1) .EQ. 'FD') THEN
		  iz1		= 1
		  meth_ind_new (ipr1) = 'FD'
		ELSE
		  IF (dh_allowed (ipr1)) THEN
		    iz1		= 2
		    meth_ind_new (ipr1) = 'DH'
		  ELSE
		    iz1		= 1
		    meth_ind_new (ipr1) = 'FD'
		  END IF
		END IF
		IF (meth_ind_old (ipr2) .EQ. 'FD') THEN
		  iz2		= 1
		  meth_ind_new (ipr2) = 'FD'
		ELSE
		  IF (dh_allowed (ipr2)) THEN
		    iz2		= 2
		    meth_ind_new (ipr2) = 'DH'
		  ELSE
		    iz2		= 1
		    meth_ind_new (ipr2) = 'FD'
		  END IF
		END IF
	      ELSE
		iz1		= 1
		iz2		= 1
	      END IF

	    ELSE						! not protons

C bugger
	ino = ino + 1


	      IF (fd_dh .NE. 'fdplusdh') STOP 'fd_dh/not protons'
	      ind1_here		= prot_ind_old (ipr1)
	      prot_ind_new(ipr1) = ind1_here
	      ind2_here		= prot_ind_old (ipr2)
	      prot_ind_new(ipr2) = ind2_here
	      DO 485 ii		= 1, n_gps
		IF ((meth_ind_old (ii) .NE. 'FD') .AND.
     1		    (meth_ind_old (ii) .NE. 'DH'))STOP'meth_ind/ii'
485	      CONTINUE					! End ii
	      IF (meth_ind_old (ipr1) .EQ. 'FD') THEN
		IF (dh_allowed (ipr1)) THEN
		  iz1		= 2
		  meth_ind_new (ipr1) = 'DH'
		ELSE
		  iz1		= 1
		  meth_ind_new (ipr1) = 'FD'
		END IF
	      ELSE
		iz1		= 1
		meth_ind_new (ipr1) = 'FD'
	      END IF
	      IF (meth_ind_old (ipr2) .EQ. 'FD') THEN
		IF (dh_allowed (ipr2)) THEN
		  iz2		= 2
		  meth_ind_new (ipr2) = 'DH'
		ELSE
		  iz2		= 1
		  meth_ind_new (ipr2) = 'FD'
		END IF
	      ELSE
		iz2		= 1
		meth_ind_new (ipr2) = 'FD'
	      END IF

	    END IF						! endif protons

	    IF (ind1_here .EQ. 2) THEN
	      en_nonij_new (ipr1) = -nat10 * (pK_int(ipr1)-pH_here) +
     1	      se_diff(iz1,ind1_here,ipr1)+fix_diff(iz1,ind1_here,ipr1)
	    ELSE
	      en_nonij_new (ipr1) = 0. +
     1	      se_diff(iz1,ind1_here,ipr1)+fix_diff(iz1,ind1_here,ipr1)
	    END IF
	    IF (ind2_here .EQ. 2) THEN
	      en_nonij_new (ipr2) = -nat10 * (pK_int(ipr2)-pH_here) +
     1	      se_diff(iz2,ind2_here,ipr2)+fix_diff(iz2,ind2_here,ipr2)
	    ELSE
	      en_nonij_new (ipr2) = 0. +
     1	      se_diff(iz2,ind2_here,ipr2)+fix_diff(iz2,ind2_here,ipr2)
	    END IF

C Remember that pair ij interactions will be counted 4-fold rather than 2-fold.

	    en_ij_inc		= 0.
	    en_ij_dec		= 0.
	    en_ij_inc_pr	= 0.
	    en_ij_dec_pr	= 0.
	    DO 490 jg		= 1, n_gps
	      IF (jg .EQ. ipr1) GOTO 490
	      IF (jg .EQ. ipr2) THEN
		jp		= prot_ind_new (jg)
	      ELSE
		jp		= prot_ind_old (jg)
	      END IF

	      IF (fd_dh .EQ. 'fdplusdh') THEN
		IF (jg .EQ. ipr2) THEN
		  IF (iz2 .EQ. 2) THEN
		    test_allowed = .TRUE.
		  ELSE
		    test_allowed = .FALSE.
		  END IF
		ELSE
		  IF ((meth_ind_old (jg).EQ.'DH').AND.
     1		      (dh_allowed(jg))) THEN
		    test_allowed = .TRUE.
		  ELSE
		    test_allowed = .FALSE.
		  END IF
		END IF
		IF ((iz1.EQ.2).OR.test_allowed) THEN
		  iz_ij		= 2
		ELSE
		  iz_ij		= 1
		END IF
	      ELSE
		iz_ij		= 1
	      END IF

	      en_ij_new (ipr1,jg) = wij (iz_ij,ind1_here,ipr1,jp,jg)
	      en_ij_new (jg,ipr1) = wij (iz_ij,jp,jg,ind1_here,ipr1)
	      IF (jg .EQ. ipr2) THEN
		en_ij_inc_pr	= en_ij_inc_pr +
     1			      en_ij_new(ipr1,jg) + en_ij_new(jg,ipr1)
		en_ij_dec_pr	= en_ij_dec_pr +
     1			      en_ij_old(ipr1,jg) + en_ij_old(jg,ipr1)
	      ELSE
		en_ij_inc	= en_ij_inc +
     1			      en_ij_new(ipr1,jg) + en_ij_new(jg,ipr1)
		en_ij_dec	= en_ij_dec +
     1			      en_ij_old(ipr1,jg) + en_ij_old(jg,ipr1)
	      END IF
490	    CONTINUE						! End jg
	    DO 500 jg		= 1, n_gps
	      IF (jg .EQ. ipr2) GOTO 500
	      IF (jg .EQ. ipr1) THEN
		jp		= prot_ind_new (jg)
	      ELSE
		jp		= prot_ind_old (jg)
	      END IF

	      IF (fd_dh .EQ. 'fdplusdh') THEN
		IF (jg .EQ. ipr1) THEN
		  IF (iz1 .EQ. 2) THEN
		    test_allowed = .TRUE.
		  ELSE
		    test_allowed = .FALSE.
		  END IF
		ELSE
		  IF ((meth_ind_old (jg).EQ.'DH').AND.
     1		      (dh_allowed(jg))) THEN
		    test_allowed = .TRUE.
		  ELSE
		    test_allowed = .FALSE.
		  END IF
		END IF
		IF ((iz2.EQ.2).OR.test_allowed) THEN
		  iz_ij		= 2
		ELSE
		  iz_ij		= 1
		END IF
	      ELSE
		iz_ij		= 1
	      END IF

	      en_ij_new (ipr2,jg) = wij (iz_ij,ind2_here,ipr2,jp,jg)
	      en_ij_new (jg,ipr2) = wij (iz_ij,jp,jg,ind2_here,ipr2)
	      IF (jg .EQ. ipr1) THEN
		en_ij_inc_pr	= en_ij_inc_pr +
     1			      en_ij_new(ipr2,jg) + en_ij_new(jg,ipr2)
		en_ij_dec_pr	= en_ij_dec_pr +
     1			      en_ij_old(ipr2,jg) + en_ij_old(jg,ipr2)
	      ELSE
		en_ij_inc	= en_ij_inc +
     1			      en_ij_new(ipr2,jg) + en_ij_new(jg,ipr2)
		en_ij_dec	= en_ij_dec +
     1			      en_ij_old(ipr2,jg) + en_ij_old(jg,ipr2)
	      END IF
500	    CONTINUE						! End jg

	    en_total_new	= en_total_old +
     1			    en_nonij_new(ipr1)-en_nonij_old(ipr1) +
     2			    en_nonij_new(ipr2)-en_nonij_old(ipr2) +
     3				  (en_ij_inc - en_ij_dec)/2. +
     4			       (en_ij_inc_pr - en_ij_dec_pr)/4.

	    en_change		= en_total_new - en_total_old
	    IF (en_change .LE. 0.) THEN
	      update_en		= .TRUE.
	      sum_upd2_1	= sum_upd2_1 + 1.
	    ELSE
	      prob_en		= enat**(-en_change)
	      sum_prob2		= sum_prob2 + prob_en
	      CALL random_num (temp4)
C ??ran	      iran4		= 73591
Clnx	      temp4		= RAN (iran4)
Clnx	      temp4		= RAND (0)
	      IF (temp4 .LT. 0.0) THEN
		IF (temp4.LT.-0.0000001) THEN
		  STOP 'random4 wrong'
		ELSE
		  temp4	= 0.0
		END IF
	      END IF
	      IF (temp4 .GT. 1.0) THEN
		IF (temp4.GE. 1.0000001) THEN
		  STOP 'random4 wrong'
		ELSE
		  temp4	= 1.0
		END IF
	      END IF
	      IF (temp4 .LT. prob_en) THEN
		update_en	= .TRUE.
		sum_upd2_2	= sum_upd2_2 + 1.
	      ELSE
		update_en	= .FALSE.
		sum_upd2_3	= sum_upd2_3 + 1.
	      END IF
	    END IF

	    IF (update_en) THEN
	      prot_ind_old (ipr1) = prot_ind_new (ipr1)
	      prot_ind_old (ipr2) = prot_ind_new (ipr2)
	      meth_ind_old (ipr1) = meth_ind_new (ipr1)
	      meth_ind_old (ipr2) = meth_ind_new (ipr2)
	      en_total_old	= en_total_new
	      en_nonij_old (ipr1) = en_nonij_new (ipr1)
	      en_nonij_old (ipr2) = en_nonij_new (ipr2)
	      intE (ipr1)	= en_nonij_old (ipr1)
	      intE (ipr2)	= en_nonij_old (ipr2)
	      DO 510 jg		= 1, n_gps
	        IF (jg .EQ. ipr1) GOTO 510
	        en_ij_old (ipr1,jg) = en_ij_new (ipr1,jg)
	        en_ij_old (jg,ipr1) = en_ij_new (jg,ipr1)
		intE (ipr1)	= intE (ipr1)+en_ij_old(ipr1,jg)/2.
510	      CONTINUE						! End jg
	      DO 520 jg		= 1, n_gps
	        IF (jg .EQ. ipr2) GOTO 520
	        en_ij_old (ipr2,jg) = en_ij_new (ipr2,jg)
	        en_ij_old (jg,ipr2) = en_ij_new (jg,ipr2)
		intE (ipr2)	= intE (ipr2)+en_ij_old(ipr2,jg)/2.
520	      CONTINUE						! End jg
	    END IF
	    CALL mc_sums (en_total_old, Z_mc, prot_ind_old, i_pass,
     1			  i_moves, moves_total, meth_ind_old, intE)

	  END IF

C ?? - move stats - then back up to top of 600 loop - are we going to do
C ?? - the stats in the Beroza paper to keep a check?
600	CONTINUE						! End m

610	CONTINUE						! End i_pass

C Normalise the energies and charges.

	av_energy		= av_energy/Z_mc
	av_prot			= av_prot/Z_mc
	DO 620 ig		= 1, n_gps
	  av_gp_prot (ig)	= av_gp_prot (ig)/Z_mc
	  av_gp_intE (ig)	= av_gp_intE (ig)/Z_mc
	  IF (fd_dh .EQ. 'fdplusdh') THEN
	    av_gp_dh (ig)	= av_gp_dh (ig)/Z_mc
	  END IF
	  IF (av_ij_write) THEN
	    DO 616 jg		= 1, n_gps
	      av_gp_wij (ig,jg)	= av_gp_wij (ig,jg) / Z_mc
616	    CONTINUE						! End jg
	  END IF
620	CONTINUE						! End ig

C??	WRITE (2,2500) (n_check (n), n=1,n_total)
C??	WRITE (2,2600) sum_upd1_2, sum_prob1
C??	WRITE (2,2620) sum_upd2_2, sum_prob2
C??	WRITE (2,2660) sum_upd1_1, sum_upd1_2, sum_upd1_3
C??	WRITE (2,2680) sum_upd2_1, sum_upd2_2, sum_upd2_3

C Store the free energy derived from the partition function (kT units),
C adding back the divergenece avoidance bit.

	frei_en_N		= -ALOG(Z_mc)+en_lowest+60.

C Get the mean energy and protonation state of the isolated aa's system.
C If fd_dh='fdplusdh' then we have 2**n_gps equivalent energies for each protn
C state in the iso aas system, so that we must add on to G of an fdonly system
C something like n_gps*ln2.

	av_prot_iso		= 0.
	av_energy_iso		= 0.
	frei_en_D		= 0.
	DO 800 ig		= 1, n_gps
	  pK_here		= pK_int (ig)
	  CALL	fractions (pK_here, pH_here, frac_p, frac_u)
	  av_prot_iso		= av_prot_iso + frac_p
	  energy_std		= - nat10 * (pK_int (ig) - pH_here)
	  av_energy_iso		= av_energy_iso + frac_p * energy_std
	  frei_en_D		= frei_en_D -
     1				  ALOG(1.+enat**(-energy_std))
800	CONTINUE						! End ig
	IF (fd_dh .EQ. 'fdplusdh') THEN
C feb 2000  frei_en_D		= frei_en_D + FLOAT(n_gps)*ALOG(2.)
	  frei_en_D		= frei_en_D - FLOAT(n_gps)*ALOG(2.)
	END IF

C bugger
C??	WRITE (6,5156) iyes, ino
C??5156	FORMAT (' *** iyes, ino = ',2I12)

	RETURN

900	WRITE (6,9000)
	CALL	EXIT

910	WRITE (6,9100)
	CALL	EXIT

920	WRITE (6,9200)
	CALL	EXIT
	END


	SUBROUTINE	rand_12 (i_12)
C	**********	*******

C Simply return i_12 = 1 or 2, randomly.

Clnx	DATA	iran1	/ 93735 /
C??ran	iran1		= 93735

	CALL random_num (temp1)
Clnx	temp1		= RAN (iran1)
Clnx	temp1		= RAND (0)
	IF (temp1.LT.0.0 .OR. temp1.GE.1.0) STOP 'random1 wrong'
	IF (temp1 .LT. 0.5) THEN
	  i_12		= 1
	ELSE
	  i_12		= 2
	END IF

	RETURN
	END


	SUBROUTINE	rand_here (n_total,n_here,moves_total,middlebin)
C	**********	*********

C Return a randomly chosen integer between 1 and n_total (inclusive).
Clnx Not entirely sure what is going on with the RAND function - we'll
Clnx keep a check on mc sampling numbers at the end/middle slots.

	INTEGER		mcbins (3)

	COMMON	/check_mcbins/	mcbins, movesav

	DATA	mcbins	/ 0, 0, 0 /
Clnx	DATA	iran2	/ 97391 /
C ??ran	iran2		= 97391
Clnx
	movesav		= moves_total/n_total
Clnx

	CALL random_num (temp2)
Clnx	temp2		= RAN (iran2)
Clnx	temp2		= RAND (0)
Clnx	IF (temp2.LT.0.0 .OR. temp2.GE.1.0) WRITE (6,*) temp2
	IF (temp2.LT.0.0 .OR. temp2.GT.1.0) THEN
	  WRITE (6,*) temp2
	  STOP 'random2 wrong'
	END IF
	fn_total	= FLOAT (n_total)
	n_here		= 1 + INT (temp2*fn_total)
	IF (n_here .EQ. (n_total+1)) n_here = n_total
	IF (n_here.LT.1 .OR. n_here.GT.n_total) THEN
	  WRITE (6,*) temp2, n_total, n_here
	  STOP 'random3 wrong'
	END IF

	IF 	(n_here .EQ. 1) THEN
	  mcbins (1)	= mcbins (1) + 1
	ELSE IF (n_here .EQ. n_total) THEN
	  mcbins (3)	= mcbins (3) + 1
	ELSE IF (n_here .EQ. middlebin) THEN
	  mcbins (2)	= mcbins (2) + 1
	END IF

	RETURN
	END

Clnx	DATA	iran2	/ 97391 /
C ??ran	iran2		= 97391
Clnx	temp2		= RAN (iran2)
Clnx	IF (temp2.LT.0.0 .OR. temp2.GE.1.0) STOP 'random2 wrong'
Clnx	fn_total	= FLOAT (n_total)
Clnx	n_here		= 1 + INT (temp2*fn_total)
Clnx	IF (n_here.LT.1 .OR. n_here.GT.n_total) STOP 'random2 wrong'
Clnx	RETURN
Clnx	END


	SUBROUTINE mc_sums (en_total_new, Z_mc, prot_ind_old, i_pass,
C	********** *******
     1			    i_moves, moves_total, meth_ind_old, intE)

C Update the mc calcn running sums with this sampled state.

	REAL		gps_sum (355,4)
	REAL		av_gp_prot (355),
     1			pK_int (355), nat10,
     2			av_gp_dh (355), av_gp_intE (355),
     3			intE (355), av_gp_wij (355,355),
     4			en_ij_old (355,355)
	INTEGER		igps (355,4), prot_ind_old (355),
     1			igps_nres (355), nq_gps (4)
	CHARACTER*2	meth_ind_old (355)
	CHARACTER*4	gps_type (355), group (355), rgps (355),
     1			status (355)
	CHARACTER*1	cgps (355)
	CHARACTER*8	fd_dh
	CHARACTER*80	mol_label
	CHARACTER*80	fd_file, dh_file
	LOGICAL		dh_allowed (355), av_ij_write

	COMMON	/constants/	bolt, elec, enat, avagad, nat10
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				dh_allowed, cgps
	COMMON	/std_energy/	group, pK_int, status
	COMMON	/this_pH/	av_energy, av_prot, av_gp_prot,
     1				av_prot_iso, av_energy_iso, av_gp_dh,
     2				av_gp_intE, av_gp_wij
	COMMON	/en_scale/	en_lowest
	COMMON	/doubleup/	fd_dh, i_read, fd_file, dh_file
	COMMON	/ij_matrix/	en_ij_old, av_ij_write

C This origin shift (within mc_sums *ONLY*) scales the lowest energy to
C -60 (recorded on the first pass), and anything above +60 becomes zero prob.
C Record averages only after one quarter of the total moves (equilibriation).

	IF (i_pass .EQ. 1) THEN
	  IF (en_total_new.LT.en_lowest) en_lowest = en_total_new
	ELSE
	  IF (i_moves .GT. moves_total/4) THEN
	    en_scaled		= en_total_new - en_lowest - 60.
	    IF (en_scaled .GT. 60.) THEN
	      prob		= 0.
	    ELSE
	      prob		= enat**(-en_scaled)
	    END IF
	    Z_mc		= Z_mc + prob
	    av_energy		= av_energy + prob*en_total_new
	    prot		= 0.
	    DO 200 ig		= 1, n_gps
	      gp_prot		= FLOAT (prot_ind_old(ig)) - 1.
	      av_gp_intE (ig)	= av_gp_intE (ig) + prob*intE (ig)
	      av_gp_prot (ig)	= av_gp_prot (ig) + prob*gp_prot
	      prot		= prot + gp_prot
	      IF (fd_dh .EQ. 'fdplusdh') THEN
		IF	(meth_ind_old (ig) .EQ. 'FD') THEN
		  gp_meth	= 0.
		ELSE IF (meth_ind_old (ig) .EQ. 'DH') THEN
		  IF (dh_allowed (ig)) THEN
		    gp_meth	= 1.
		  ELSE
		    gp_meth	= 0.
		  END IF
		END IF
		av_gp_dh (ig)	= av_gp_dh (ig) + prob*gp_meth
	      END IF
	      IF (av_ij_write) THEN
		DO 180 jg	= 1, n_gps
	   av_gp_wij(ig,jg) = av_gp_wij(ig,jg)+prob*en_ij_old(ig,jg)
180		CONTINUE					! End jg
	      END IF
200	    CONTINUE						! End ig
	    av_prot		= av_prot + prob*prot
	  END IF
	END IF

	RETURN
	END


	SUBROUTINE	get_pKs
C	**********	*******

	REAL		pH_energy (300), pK_gps (355),
     1			pH_prot (300), pH_gp_prot (355,300),
     2			pH_energy_iso (300), pH_prot_iso (300),
     3			gps_sum (355,4), pH_gp_dh (355,300),
     4			dh_at_pK (355),pH_ham(300),pH_ham_iso(300),
     5			pH_gp_intE (355,300)
	INTEGER		igps (355,4), igps_nres (355), nq_gps (4)
	CHARACTER*4	gps_type (355), rgps (355)
	CHARACTER*1	cgps (355)
	CHARACTER*8	method, fd_dh
	CHARACTER*80	mol_label
	CHARACTER*80	other_file, fd_file, dh_file
	LOGICAL		Vf_mod, other_upd, partials, partial_ijs,
     1			dh_allowed (355)
Ctry
	REAL		prot_again (300)

	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				dh_allowed, cgps
	COMMON	/params/	pH_low, pH_top, n_pH, pH_div, method,
     1				red_limit,other_upd,other_file,Vf_mod,
     2				partials, partial_ijs, couple_kT,
     3				mc_steps, pH_fix_mc, fix_mc, temp_K
	COMMON	/results/	pH_energy, pH_prot, pH_gp_prot,pK_gps,
     1				pH_energy_iso, pH_prot_iso, pH_gp_dh,
     2				dh_at_pK, pH_ham, pH_ham_iso,
     3				pH_gp_intE
	COMMON	/doubleup/	fd_dh, i_read, fd_file, dh_file
Ctry
	COMMON	/protagain/	prot_again

9000	FORMAT (' *** trouble with t" weights in get_pKs')

Ctry
	DO 160 i_pH		= 1, n_pH
	  prot_again (i_pH)	= 0.
	  DO 140 ig		= 1, n_gps
	    prot_again(i_pH) = prot_again(i_pH)+pH_gp_prot(ig,i_pH)
140	  CONTINUE						! End ig
160	CONTINUE						! End i_pH
C try

	DO 300 ig		= 1, n_gps
	  DO 200 i_pH		= 1, n_pH
	    pH_here		= pH_low + pH_div*FLOAT(i_pH-1)
	    test_here		= pH_gp_prot (ig,i_pH)
	    IF (fd_dh.EQ.'fdplusdh') dh_here = pH_gp_dh (ig,i_pH)
	    IF (test_here .LT. 0.5) THEN
	      IF (i_pH .EQ. 1) THEN
		pK_gps (ig)	= -999.
		IF (fd_dh .EQ. 'fdplusdh') dh_at_pK (ig) = -999.
		GOTO 300
	      ELSE
		del_here	= 0.5 - test_here
		del_last	= test_last - 0.5
		wt_here		= del_last / (del_here+del_last)
		wt_last		= del_here / (del_here+del_last)
		IF ((wt_here.LT.0.) .OR. (wt_last.LT.0.)) GOTO 900
		pK_gps (ig)	= wt_here*pH_here + wt_last*pH_last
		IF (fd_dh .EQ. 'fdplusdh') THEN
		  dh_at_pK (ig)	= wt_here*dh_here + wt_last*dh_last
		END IF
		GOTO 300
	      END IF
	    END IF
	    test_last		= test_here
	    pH_last		= pH_here
	    IF (fd_dh .EQ. 'fdplusdh') dh_last	= dh_here
200	  CONTINUE						! End i_pH
	  pK_gps (ig)		= 999.
	  IF (fd_dh .EQ. 'fdplusdh') dh_at_pK(ig) = 999.
300	CONTINUE						! End ig

	RETURN

900	WRITE (6,9000)
	CALL	EXIT
	END


	SUBROUTINE	output (av_gp_wij, pH_red, symm_diff_top)
C	**********	******

	REAL		pH_energy (300),
     1			pH_prot (300), pH_gp_prot (355,300),
     2			pK_gps (355), pK_int (355),
     3			pH_energy_iso (300),
     4			pH_prot_iso (300), gps_sum (355,4), nat10,
     5			pH_gp_dh (355,300), dh_at_pK (355),
     6			pH_buf (300),pH_ham(300),pH_ham_iso(300),
     7			pH_gp_intE (355,300), pH_point (300),
     8			std_point (300), av_gp_wij (355,355)
	INTEGER		igps (355,4), pH_red (2,300), igps_nres (355),
     1			nq_gps (4), mcbins (3)
	CHARACTER*4	gps_type (355), group (355), rgps (355),
     1			status (355)
	CHARACTER*1	cgps (355)
	CHARACTER*8	method, fd_dh
	CHARACTER*80	mol_label
	CHARACTER*80	other_file, fd_file, dh_file
	LOGICAL		Vf_mod, other_upd, partials, partial_ijs,
     1			dh_allowed (355), found_prot_pI, found_iso_pI
Ctry
	REAL		prot_again (300)

	COMMON	/constants/	bolt, elec, enat, avagad, nat10
	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				dh_allowed, cgps
	COMMON	/params/	pH_low, pH_top, n_pH, pH_div, method,
     1				red_limit,other_upd,other_file,Vf_mod,
     2				partials, partial_ijs, couple_kT,
     3				mc_steps, pH_fix_mc, fix_mc, temp_K
	COMMON	/std_energy/	group, pK_int, status
	COMMON	/results/	pH_energy, pH_prot, pH_gp_prot,pK_gps,
     1				pH_energy_iso, pH_prot_iso, pH_gp_dh,
     2				dh_at_pK, pH_ham, pH_ham_iso,
     3				pH_gp_intE
	COMMON	/doubleup/	fd_dh, i_read, fd_file, dh_file
	COMMON	/check_mcbins/	mcbins, movesav
Ctry
	COMMON	/protagain/	prot_again
	COMMON	/pI_data/	num_acids, num_bases, sum_fixQ

1210	FORMAT (/,'Where a symmetrisation move of more than 5 e.mV
     1 has occurred, THEN the - ')
1220	FORMAT (/,' largest fractional ij/ji discrepancy = ',F6.3)
1300	FORMAT (/,20X,' *** First the group pKa"s ***')
1340	FORMAT (/,'  ig   nres   res     pK_int      pKa',/)
1350	FORMAT (/,' *** NOTE THAT THIS IS AN FD + DH PK_CALC RUN ***')
1360	FORMAT (/,'  ig   nres   res     pK_int      pKa
     1    frac DH at pKa',/)
1400	FORMAT (1X,I3,2X,A1,I4,2X,A4,3X,F7.2,3X,F7.2)
1410	FORMAT (1X,I3,2X,A1,I4,2X,A4,3X,F7.2,3X,F7.2,7X,F7.2)
1500	FORMAT (/,15X,' *** And now on to the pH-dependence ***')

1535	FORMAT (/,14X,'---------kT/molecule--------')
1540	FORMAT ('  pH  n_red',
     1'  {G_by_Z  :  G_by_Q  :  <H>  :  H+bnd}_to_iso H+(iso) ',
     2'Q_prot  Q_iso',/)
1600	FORMAT (1X,F4.1,1X,I3,1X,
     1 F10.3,1X,F10.3,1X,F10.3,1X,F7.2,8X,F7.2,1X,F6.1,1X,F6.1)

1545	FORMAT (/,23X,'----kT/molecule----')
1550	FORMAT ('  pH       ',
     1'  {        :  G_by_Q  :  <H>  :  H+bnd}_to_iso H+(iso) ',
     2'Q_prot  Q_iso',/)
1610	FORMAT (1X,F4.1,1X,3X,1X,
     1   10X,1X,F10.3,1X,F10.3,1X,F7.2,8X,F7.2,1X,F6.1,1X,F6.1)

1700	FORMAT (9X,14(1X,F4.1))
1720	FORMAT (A1,I4,1X,A4,14(1X,F4.2))
1800	FORMAT (/,' mc bins bottom, middle, top = ',3I8)
1805	FORMAT (/,' For pI calculation we use:',/,
     1		'number of acids =   ',I5,/,
     2		'number of bases =   ',I5,/,
     3		'which should sum to ',I5,' ionisable groups'/,
     4		'and sum of non-ionisable charge = ',F7.2)
1810	FORMAT (/,'folded protein  pI = ',F7.2)
1820	FORMAT (/,'unable to determine folded protein pI')
1830	FORMAT (/,'iso amino acids pI = ',F7.2)
1840	FORMAT (/,'unable to determine iso aas pI')

2000	FORMAT ('pk_calc_more.out for nos groups/pH pts/method = ',
     1		/,I5,I5,2X,A8,/,
     2		'group sections follow res:chain:nres:pK_int:pK',
     3		' and pH pt charges',/)
2100	FORMAT ('group ',A4,1X,A1,I4,2X,F7.2,2X,F7.2)
2150	FORMAT ('ionisable group ',A4,1X,A1,I4,2X,F7.2,2X,F7.2)
2200	FORMAT (6(F5.2,1X,F5.3,1X))
2300	FORMAT (6(F5.2,1X,F5.2,1X))

C Update August 2002 to add another output file (formatted - currently)
C for various ionisable group and pH point info - for subsequent avging.
C "pk_calc_more.out"
C	number of ionisable groups, number of pH points, MC or RS run
C	identifiers for each group and calculated pKa
C		followed by charge at each pH point for this group
C	various information for each pH point (as in standard o/p)

	OPEN (UNIT=3, NAME='pk_calc_more.out', TYPE='NEW')
	WRITE (3,2000) n_gps, n_pH, method

	IF (partial_ijs) WRITE (2,1210)
	WRITE (2,1220) symm_diff_top
	WRITE (2,1300)
	IF (fd_dh .EQ. 'fdplusdh') THEN
	  WRITE (2,1350)
	  WRITE (2,1360)
	ELSE
	  WRITE (2,1340)
	END IF
	DO 200 ig	= 1, n_gps
	  IF (fd_dh .EQ. 'fdplusdh') THEN
	  WRITE (2,1410) ig,cgps(ig),igps_nres(ig),rgps(ig),pK_int(ig),
     1			   pK_gps(ig), dh_at_pK(ig)
	  ELSE
	  WRITE (2,1400) ig,cgps(ig),igps_nres(ig),rgps(ig),pK_int(ig),
     1			   pK_gps(ig)
	  END IF
	  WRITE (3,2100) rgps(ig), cgps(ig), igps_nres(ig),
     1			 pK_int(ig), pK_gps(ig)
	  WRITE (3,2200) (pH_low+pH_div*FLOAT(i_pH-1),
     1			  pH_gp_prot(ig,i_pH), i_pH=1,n_pH)
200	CONTINUE						! End ig

	charge_fullyH	= sum_fixQ + FLOAT (num_bases)
	sum_gps		= FLOAT (num_acids) + FLOAT (num_bases)

C ?? - we should update the following o/p loop with some optione for
C ?? - mc write-out - n_steps etc /stats on reliability - replacing the
C ?? - reduced sites info for the red_site method.

	WRITE (2,1500)
	IF (method .EQ. 'mon_crlo') THEN
	  WRITE (2,1545)
	  WRITE (2,1550)
	  WRITE (3,1545)
	  WRITE (3,1550)
	ELSE
	  WRITE (2,1535)
	  WRITE (2,1540)
	  WRITE (3,1535)
	  WRITE (3,1540)
	END IF
	found_prot_pI	= .FALSE.
	found_iso_pI	= .FALSE.
	DO 300 i_pH	= 1, n_pH
	  pH_here	= pH_low + pH_div*FLOAT(i_pH-1)
	  en_to_iso	= pH_energy (i_pH) - pH_energy_iso (i_pH)
	  prot_to_iso	= pH_prot (i_pH) - pH_prot_iso (i_pH)

	  charQ_iso	= charge_fullyH-(sum_gps-pH_prot_iso(i_pH))
	  charQ_prot	= charQ_iso + prot_to_iso

	  IF (i_pH .NE. 1) THEN
	    IF (.NOT.found_prot_pI) THEN
	      IF ((charQ_prot_last.GT.0.) .AND.
     1		  (charQ_prot .LT. 0.)) THEN
		frac	= (0.-charQ_prot)/(charQ_prot_last-charQ_prot)
		prot_pI	= pH_here - pH_div*frac
		found_prot_pI	= .TRUE.
	      END IF
	    END IF
	    IF (.NOT.found_iso_pI) THEN
	      IF ((charQ_iso_last.GT.0.) .AND.
     1		  (charQ_iso .LT. 0.)) THEN
		frac	= (0.-charQ_iso)/(charQ_iso_last-charQ_iso)
		prot_iso_pI	= pH_here - pH_div*frac
		found_iso_pI	= .TRUE.
	      END IF
	    END IF
	  END IF

	  IF (i_pH .EQ. 1) THEN
	    IF (method .EQ. 'mon_crlo') THEN
	      IF ( ABS(pH_here-pH_fix_mc) .GT. 0.001) STOP 'mc_fix'
	      en_check	= fix_mc
	    ELSE
	      en_check	= en_to_iso
	    END IF
	  ELSE

Ctry - separate mc and rs - use simple Q calculation for mc
	   IF (method .EQ. 'mon_crlo') THEN
	    av_Qdiff  = ((prot_again(i_pH)-pH_prot_iso(i_pH)) +
     1			 (prot_again(i_pH-1)-pH_prot_iso(i_pH-1)))/2.
	    en_check	= en_check + nat10*pH_div*av_Qdiff
	    en_to_iso = 999.
	   ELSE
	    av_Qdiff	= ((pH_prot(i_pH)  -pH_prot_iso(i_pH)) +
     1			   (pH_prot(i_pH-1)-pH_prot_iso(i_pH-1)))/2.
	    en_check	= en_check + nat10*pH_div*av_Qdiff
	   END IF

	  END IF

Ctry - separate the mc and rs writes
	  ham_to_iso	= pH_ham (i_pH) - pH_ham_iso (i_pH)
	  IF (method .EQ. 'mon_crlo') THEN
	    WRITE (2,1610) pH_here, en_check, ham_to_iso,
     1			   (prot_again (i_pH) - pH_prot_iso (i_pH)),
     2			   pH_prot_iso (i_pH), charQ_prot, charQ_iso
	    WRITE (3,1610) pH_here, en_check, ham_to_iso,
     1			   (prot_again (i_pH) - pH_prot_iso (i_pH)),
     2			   pH_prot_iso (i_pH), charQ_prot, charQ_iso
	  ELSE
	    WRITE (2,1600) pH_here,
     1			   pH_red (1,i_pH),
     2			   en_to_iso,en_check,ham_to_iso,prot_to_iso,
     3			   pH_prot_iso (i_pH), charQ_prot, charQ_iso
	    WRITE (3,1600) pH_here,
     1			   pH_red (1,i_pH),
     2			   en_to_iso,en_check,ham_to_iso,prot_to_iso,
     3			   pH_prot_iso (i_pH), charQ_prot, charQ_iso
	  END IF

	  charQ_prot_last	= charQ_prot
	  charQ_iso_last	= charQ_iso

300	CONTINUE						! End i_pH

C Write out information to obtain pIs.

	WRITE (2,1805) num_acids, num_bases, n_gps, sum_fixQ
	IF (found_prot_pI) THEN
	  WRITE (2,1810) prot_pI
	ELSE
	  WRITE (2,1820)
	END IF
	IF (found_iso_pI) THEN
	  WRITE (2,1830) prot_iso_pI
	ELSE
	  WRITE (2,1840)
	END IF

C The pH_gp_dh (ig,i_pH) array should track fd/dh changes as fn pH - so we
C should see where eg a K goes to DH because a sb partner protonates.

	IF (fd_dh .EQ. 'fdplusdh') THEN
	  IF (n_pH .LE. 14) THEN
	    DO 380 i_pH		= 1, n_pH
	      pH_buf (i_pH)	= pH_low + pH_div*FLOAT(i_pH-1)
380	    CONTINUE
	    WRITE (2,*)
	    WRITE (2,*) 'DH fractions'
	    WRITE (2,*)
	    WRITE (2,1700) (pH_buf (i_pH), i_pH = 1, n_pH)
	    WRITE (2,*)
	    DO 400 ig		= 1, n_gps
	      WRITE (2,1720) cgps(ig), igps_nres(ig), rgps(ig),
     1			     (pH_gp_dh (ig,i_pH), i_pH = 1, n_pH)
400	    CONTINUE
	  END IF
	END IF

C For the newer file on unit 3, write out residue/pH point <int energies>.

	WRITE (3,*)
	WRITE (3,*) 'Average Internal Energies per Ionisable per pH
     1 (kT/molecule rel to iso aa)'
	WRITE (3,*)

	DO 500 ig		= 1, n_gps
	  DO 480 i_pH		= 1, n_pH
	    pH_point (i_pH)	= pH_low + pH_div*FLOAT(i_pH-1)
	    pH_here		= pH_point (i_pH)
	    pK_here		= pK_int (ig)
	    CALL fractions (pK_here, pH_here, frac_p, frac_u)
	    energy_std		= - nat10 * (pK_int (ig) - pH_here)
	    std_point (i_pH)	= frac_p * energy_std
480	  CONTINUE						! End i_pH
	  WRITE (3,2150) rgps(ig), cgps(ig), igps_nres(ig),
     1			 pK_int(ig), pK_gps(ig)
	  WRITE (3,2300) ( pH_point (i_pH),
     1			 (pH_gp_intE(ig,i_pH) - std_point(i_pH)),
     2			  i_pH=1,n_pH )
500	CONTINUE						! End ig
C??aliens - get a file going for pH_gp_intE - as we have for pH_gp_prot

Clnx Just a little check on mc sampling.

	WRITE (2,1800) mcbins

C Update Feb 2004 we could write out a matrix of ij interactions from
C av_gp_wij, but only do it currently in the 'alexp' project version.
C Note that av_gp_wij will be the ij energy at whatever pH we set to take it
C (see calc_mc), and so we may get zero if not either i or j are unionised.

	CLOSE (UNIT=2)
	CLOSE (UNIT=3)

	RETURN
	END


	SUBROUTINE	get_filename (rec, file)
C	**********	************

C Remove leading blanks from file name.

	CHARACTER*80	rec, file
	LOGICAL		started

C Initialise the file string.

	DO 160	i	= 1, 80
	  file (i:i)	= ' '
160	CONTINUE						! End i

	n		= 1
	started		= .FALSE.
	DO 200	i	= 1, 80
	  IF (rec (i:i) .EQ. ' ') THEN
	    IF (started) GOTO 300
	  ELSE
	    started	= .TRUE.
	    file (n:n)	= rec (i:i)
	    n		= n + 1
	  END IF
200	CONTINUE						! End i

300	CONTINUE
	RETURN
	END


	SUBROUTINE	leader (char_array, itop)
C	**********	******

	CHARACTER*60	char_array

	itop	= 1
	DO WHILE (char_array (itop:itop) .NE. ' ')
	  itop	= itop + 1
	END DO
	itop	= itop - 1

	RETURN
	END


	SUBROUTINE	couple_scf (couple_kT)
C	**********	**********

C Here for couple_nodh on - propagate nodh for coupling > couple_kT.
C At present this is just single step propagation - not iterative - so we
C copy onto a mirror array.

	REAL		se_diff (2,2,355), fix_diff (2,2,355),
     1			wij (2,2,355,2,355), gps_sum (355,4)
	INTEGER		igps (355,4), igps_nres (355), nq_gps (4)
	CHARACTER*80	mol_label
	CHARACTER*4	gps_type (355), rgps (355)
	CHARACTER*1	cgps (355)
	LOGICAL		dh_allowed (355), change_here, dh_copy (355)

	COMMON	/gps_info/	mol_label, n_gps, nq_gps, igps,
     1				igps_nres, rgps, gps_sum, gps_type,
     2				dh_allowed, cgps
	COMMON	/interact/	se_diff, fix_diff, wij

2000	FORMAT (/,'*** use NO_DH propagation/coupling=',F5.1,' kT ***')
2100	FORMAT ('coupling switch to NO_DH for ',I4,1X,A1,I4,1X,A4)
2200	FORMAT ('*** done NO_DH propagation: ',I4,' gps changed ***',/)

	WRITE (2,2000)
	DO 200 i		= 1, n_gps
	  dh_copy (i)		= dh_allowed (i)
200	CONTINUE						! End i
	iz			= 1
	n_changed		= 0
	DO 300 i		= 1, n_gps
	  IF (dh_copy (i)) THEN
	  DO 260 j		= 1, n_gps
	    IF (j .NE. i) THEN
	      IF (.NOT. dh_copy (j)) THEN
		change_here	= .FALSE.
		DO 240 m	= 1, 2
		  DO 240 n	= 1, 2
		    IF (ABS (wij  (iz,m,i,n,j)).GE.couple_kT) THEN
		      change_here = .TRUE.
		    END IF
240		CONTINUE					! End n,m
		IF (change_here) THEN
		  dh_allowed(i) = .FALSE.
		  n_changed	= n_changed + 1
		  WRITE (2,2100) i,cgps(i),igps_nres(i),rgps(i)
		  GOTO 300
		END IF
	      END IF
	    END IF
260	  CONTINUE						! End j
	  END IF
300	CONTINUE						! End i
	WRITE (2,2200) n_changed

	RETURN
	END

